searchNodes=[{"doc":"A sharp EventStoreDB 20+ client backed by mint Streams Spear uses the term stream across different contexts. There are four possible contexts for the term stream in Spear: HTTP2 streams of data gRPC stream requests, responses, and bidirectional communication EventStoreDB streams of events Elixir Stream s Descriptions of each are given in the Streams guide . Connections Spear needs a connection to interact with an EventStoreDB. Spear provides the Spear.Connection GenServer for this purpose. Connections are referred to as &quot; conn &quot; in the documentation. Like an Ecto.Repo , it can be handy to have a module which itself represents a connection to an EventStoreDB. For this, Spear provides Spear.Client which allows one to call any function in Spear without the conn argument on the client module. defmodule MyApp.MyClient do use Spear.Client , otp_app : :my_app end iex&gt; MyApp.MyClient . start_link ( connection_string : &quot;esdb://localhost:2113&quot; ) iex&gt; MyApp.MyClient . stream! ( &quot;my_stream&quot; ) |&gt; Enum . to_list ( ) [ % Spear.Event { } , % Spear.Event { } , .. ] See the Spear.Client module for more information. Record interfaces The Spear.Records.* modules provide macro interfaces for matching and creating messages sent and received from the EventStoreDB. These are mostly intended for internal uses such as the mapping between a Spear.Records.Streams.read_resp/0 and a Spear.Event.t/0 , but they can also be used to extract values from any raw response records (e.g. those returned from functions where the raw?: true option is passed). iex&gt; import Spear.Records.Streams , only : [ read_resp : 0 , read_resp : 1 ] iex&gt; event = Spear . stream! ( conn , &quot;my_stream&quot; , raw? : true ) |&gt; Enum . take ( 1 ) |&gt; List . first ( ) { :&quot;event_store.client.streams.ReadResp&quot; , { :checkpoint , .. } } iex&gt; match? ( read_resp ( ) , event ) true iex&gt; match? ( read_resp ( content : { :checkpoint , _ } ) , event ) true Macros in these modules are generated with Record.defrecord/2 with the contents extracted from the protobuf messages (indirectly via :gpb ).","ref":"Spear.html","title":"Spear","type":"module"},{"doc":"Acknowledges that an event received as part of a persistent subscription was successfully handled Although ack/3 can accept a Spear.Event.t/0 alone, the underlying gRPC call acknowledges a batch of event IDs. Spear . ack ( conn , subscription , events |&gt; Enum . map ( &amp; Spear.Event . id / 1 ) ) should be preferred over Enum . each ( events , &amp; Spear . ack ( conn , subscription , Spear.Event . id ( &amp;1 ) ) ) As the acknowledgements will be batched. This function (and nack/4 ) are asynchronous casts to the connection process. Examples # some stream with 3 events stream_name = &quot;my_stream&quot; group_name = &quot;spear_iex&quot; settings = % Spear.PersistentSubscription.Settings { } get_event_and_ack = fn conn , sub -&gt; receive do % Spear.Event { } = event -&gt; :ok = Spear . ack ( conn , sub , event ) event after 3_000 -&gt; :no_events end end iex&gt; Spear . create_persistent_subscription ( conn , stream_name , group_name , settings ) :ok iex&gt; { :ok , sub } = Spear . connect_to_persistent_subscription ( conn , self ( ) , stream_name , group_name ) iex&gt; get_event_and_ack . ( conn , sub ) % Spear.Event { .. } iex&gt; get_event_and_ack . ( conn , sub ) % Spear.Event { .. } iex&gt; get_event_and_ack . ( conn , sub ) % Spear.Event { .. } iex&gt; get_event_and_ack . ( conn , sub ) :no_events iex&gt; Spear . cancel_subscription ( conn , sub ) :ok","ref":"Spear.html#ack/3","title":"Spear.ack/3","type":"function"},{"doc":"Appends an enumeration of events to an EventStoreDB stream event_stream is an enumerable which may either be a collection of Spear.Event.t/0 structs or more low-level Spear.Records.Streams.append_resp/0 records. In cases where the enumerable produces Spear.Event.t/0 structs, they will be lazily mapped to Spear.Records.Streams.append_req/0 records before being encoded to wire data. See the Writing Events guide for more information about writing events. Options :expect - (default: :any ) the expectation to set on the status of the stream. The write will fail if the expectation fails. See Spear.ExpectationViolation for more information about expectations. :timeout - (default: 5_000 - 5s) the GenServer timeout for calling the RPC. :raw? - (default: false ) a boolean which controls whether the return signature should be a simple :ok | {:error, any()} or {:ok, AppendResp.t()} | {:error, any()} . This can be used to extract metadata and information from the append response which is not available through the simplified return API, such as the stream's revision number after writing the events. :credentials - (default: nil ) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details. Examples iex&gt; [ Spear.Event . new ( &quot;es_supported_clients&quot; , %{ } ) ] ...&gt; |&gt; Spear . append ( conn , expect : :exists ) :ok iex&gt; [ Spear.Event . new ( &quot;es_supported_clients&quot; , %{ } ) ] ...&gt; |&gt; Spear . append ( conn , expect : :empty ) { :error , % Spear.ExpectationViolation { current : 1 , expected : :empty } }","ref":"Spear.html#append/4","title":"Spear.append/4","type":"function"},{"doc":"Appends an enumeration of events to an EventStoreDB stream BatchAppend is a feature added in EventStoreDB version 21.6.0 which aims to optimize append throughput. It works like a persistent subscription in reverse: the client sends chunks of events to write and once the events have been committed, the client receives an acknowledgement message. BatchAppends have a life cycle: a new batch append request is created by passing the :new atom as the request_id argument and a request is concluded by calling Spear.cancel_subscription/2 on the request_id . See the Writing Events guide for more information about batching and when to prefer the append_batch/5 function over append/4 . Fragmentation By default, each invocation of append_batch/5 sends a single protobuf message across the wire for all events in the event_stream argument. If the event_stream argument is very large (&gt; ~1MB), this may be undesirable from a networking perspective. The :done? flag can be set to false to mark a batch as a fragment, which prevents the EventStoreDB from attempting to commit any events sent for the batch until a fragment with the :done? flag set to true is sent. Each batch of events after the first fragment must pass the initial fragment's batch_id in the :batch_id option. A set of fragments can be concluded by sending a final append_batch/5 with the :done? option set to true . Options :done? - (default: true ) controls whether the current chunk of events being written is complete. See the &quot;Fragmentation&quot; section above for more details. :batch_id - (default: Spear.Uuid.uuid_v4() ) the unique ID of the batch of events being appended. This must be passed the batch_id returned by the first request which sets :done? to false until a final fragment is appended ( done?: true ). See the &quot;Fragmentation&quot; section above for more details. :expect - (default: :any ) the expectation to set on the status of the stream. The write will fail if the expectation fails. See Spear.ExpectationViolation for more information about expectations. :send_ack_to - (default: self() ) a process or process name which should receive acknowledgement messages detailing whether a batch has succeeded or failed to be committed by the deadline. :raw? - (default: false ) a boolean which controls whether messages emitted to the :send_ack_to process are decoded from Spear.Records.Streams.batch_append_resp/0 records. Spear preserves most of the information when decoding the record into the Spear.BatchAppendResult.t/0 struct, but it discards duplicated information such as stream name and expected revision. Setting the :raw? flag allows one to decode the record however they wish. :credentials - (default: nil ) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details. :deadline - (default: nil ) the deadline for the batch to be appended. This is like :timeout but is interpreted on the EventStoreDB server. This may be a DateTime or a tuple of {seconds, nanos} since 1970 (smeared) but may be a tuple {:duration, seconds, nanos} when using EventStoreDB version 21.10.5 or higher. :timeout - (default: 5_000 ) the timeout for the initial call to open the batch request. Examples iex&gt; { :ok , first_batch_id , request_id } = ...&gt; Spear . append_batch ( first_batch , conn , :new , first_stream_name ) { :ok , &quot;496ba076-098f-4108-a2ca-c73f7b94c06f&quot; , # Reference &lt; 0.1691282361 . 2492989441.105913 &gt; } iex&gt; receive do ...&gt; % Spear.BatchAppendResult { request_id : ^ request_id , batch_id : ^ first_batch_id , result : result } -&gt; ...&gt; result ...&gt; end :ok iex&gt; { :ok , second_batch_id , ^ request_id } = ...&gt; Spear . append_batch ( second_batch , conn , batch_id , second_stream_name ) { :ok , &quot;3a1ed972-716c-4679-9cc7-c23c3544e538&quot; , # Reference &lt; 0.1691282361 . 2492989441.105913 &gt; } iex&gt; receive ( do : ( % Spear.BatchAppendResult { request_id : ^ request_id , batch_id : ^ second_batch_id , result : result } ) -&gt; result ) ) :ok iex&gt; { :ok , third_batch_id , ^ request_id } = ...&gt; Spear . append_batch ( third_batch , conn , batch_id , third_stream_name ) { :ok , &quot;b4eb1330-8c59-48d0-8a0b-2df33672cc0b&quot; , # Reference &lt; 0.1691282361 . 2492989441.105913 &gt; } iex&gt; receive ( do : ( % Spear.BatchAppendResult { request_id : ^ request_id , batch_id : ^ third_batch_id , result : result } ) -&gt; result ) ) :ok iex&gt; Spear . cancel_subscription ( conn , request_id ) :ok","ref":"Spear.html#append_batch/5","title":"Spear.append_batch/5","type":"function"},{"doc":"A convenience wrapper around append_batch/5 for transforming a stream into a batch append operation. The append_batch/5 function provides fine-grained control over the batch append feature. This function transforms an input stream of batches to apply the append_batch/5 on all of them, making sure to clean up the request once the batch is finished. The expected batch_stream is an enumerable with each element follows the format { stream_name :: String . t ( ) , events :: [ Spear.Event . t ( ) ] } # or { stream_name :: String . t ( ) , events :: [ Spear.Event . t ( ) ] , opts :: Keyword . t ( ) } Where opts can be any option below. The options below are applied to each call to append_batch/5 when provided, except :credentials which is only applied when specified on the first batch. The resulting stream must be run (with an Enum function or Stream.run/1 ). Each element is mapped to the acknowledgement Spear.BatchAppendResult.t/0 responses for each batch attempting to be appended. Options :expect - (default: :any ) the expectation to set on the status of the stream. The write will fail if the expectation fails. See Spear.ExpectationViolation for more information about expectations. :raw? - (default: false ) a boolean which controls whether messages emitted to the :send_ack_to process are decoded from Spear.Records.Streams.batch_append_resp/0 records. Spear preserves most of the information when decoding the record into the Spear.BatchAppendResult.t/0 struct, but it discards duplicated information such as stream name and expected revision. Setting the :raw? flag allows one to decode the record however they wish. :credentials - (default: nil ) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details. :timeout - (default: 5_000 ) the timeout for the initial call to open the batch request. After the first batch, this argument instead controls how long each append_batch/5 operation will await an acknowledgement. Examples batch_stream |&gt; Spear . append_batch_stream ( conn ) |&gt; Enum . reduce_while ( :ok , fn ack , _acc -&gt; case ack . result do :ok -&gt; { :cont , :ok } { :error , reason } -&gt; { :halt , { :error , reason } } end end ) #=&gt; :ok","ref":"Spear.html#append_batch_stream/2","title":"Spear.append_batch_stream/2","type":"function"},{"doc":"Cancels a subscription This function will cancel a subscription if the provided subscription_reference exists, but is idempotent: if the subscription_reference is not an active subscription reference, :ok will be returned. Subscriptions are automatically cancelled when a subscribe process exits. Examples iex&gt; { :ok , subscription } = Spear . subscribe ( conn , self ( ) , &quot;my_stream&quot; ) { :ok , # Reference &lt; 0.4293953740 . 2750676995.30541 &gt; } iex&gt; Spear . cancel_subscription ( conn , subscription ) :ok iex&gt; Spear . cancel_subscription ( conn , subscription ) :ok","ref":"Spear.html#cancel_subscription/3","title":"Spear.cancel_subscription/3","type":"function"},{"doc":"Changes a user's password by providing the current password This can be accomplished regardless of the current credentials since the user's current password is provided. Options All options are passed to Spear.request/5 . Examples iex&gt; Spear . create_user ( conn , &quot;Aladdin&quot; , &quot;aladdin&quot; , &quot;changeit&quot; , [ &quot;$ops&quot; ] ) :ok iex&gt; Spear . change_user_password ( conn , &quot;aladdin&quot; , &quot;changeit&quot; , &quot;open sesame&quot; ) :ok","ref":"Spear.html#change_user_password/5","title":"Spear.change_user_password/5","type":"function"},{"doc":"Reads the cluster information from the connected EventStoreDB Returns a list of members which are clustered to the currently connected EventStoreDB. Options Options are passed to request/5 . Examples iex&gt; Spear . cluster_info ( conn ) { :ok , [ % Spear.ClusterMember { address : &quot;127.0.0.1&quot; , alive? : true , instance_id : &quot;eba4c27f-e443-4b21-8756-00845bc5cda1&quot; , port : 2113 , state : :Leader , timestamp : ~U[2021-04-19 17:25:17.875824Z] } ] }","ref":"Spear.html#cluster_info/2","title":"Spear.cluster_info/2","type":"function"},{"doc":"Subscribes a process to an existing persistent subscription Persistent subscriptions can be gracefully closed with cancel_subscription/3 just like subscriptions started with subscribe/4 . The subscription will be cancelled by the connection process if the subscriber process exits. Persistent subscriptions are an alternative to standard subscriptions (via subscribe/4 ) which use ack/3 and nack/4 to exert backpressure and allow out-of-order and batch processing within a single consumer and allow multiple connected consumers at once. In standard subscriptions (via subscribe/4 ), if a client wishes to handle events in order without reprocessing, the client must keep track of its own position in a stream, either in memory or using some sort of persistence such as PostgreSQL or mnesia for durability. In contrast, persistent subscriptions are stateful on the server-side: the EventStoreDB will keep track of which events have been positively and negatively acknowledged and will only emit events which have not yet been processed to any connected consumers. This allows one to connect multiple subscriber processes to a persistent subscription stream-group combination in a strategy called Competing Consumers . Note that persistent subscription events are not guaranteed to be processed in order like the standard subscriptions because of the ability to nack/4 and reprocess or park a message. While this requires special considerations when authoring a consumer, it allows one to easily write a consumer which does not head-of-line block in failure cases. The subscriber will receive a message {:eos, subscription, reason} when the subscription is closed by the server. :closed denotes that the EventStoreDB connection has been severed and :dropped denotes that the EventStoreDB has explicitly told the subscriber that the subscription is terminated. This can occur for persistent subscriptions in the case where the subscription is deleted (e.g. via Spear.delete_persistent_subscription/4 ). subscription is the reference returned by this function. iex&gt; Spear . create_persistent_subscription ( conn , &quot;asdf&quot; , &quot;asdf&quot; , % Spear.PersistentSubscription.Settings { } ) :ok iex&gt; Spear . connect_to_persistent_subscription ( conn , self ( ) , &quot;asdf&quot; , &quot;asdf&quot; ) { :ok , # Reference &lt; 0.515780924 . 2297430020.166204 &gt; } iex&gt; flush :ok iex&gt; Spear . delete_persistent_subscription ( conn , &quot;asdf&quot; , &quot;asdf&quot; ) :ok iex&gt; flush { :eos , # Reference &lt; 0.515780924 . 2297430020.166204 &gt; , :dropped } :ok Like subscriptions from subscribe/4 , events can be correlated to their subscription by the :subscription key in each Spear.Event.metadata map. Note that persistent subscriptions to the :all stream with server-side filtering is a feature introduced in EventStoreDB v21.6.0. Attempting to use the :all stream on older EventStoreDB versions will fail. Backpressure Persistent subscriptions allow the subscriber process to exert backpressure on the EventStoreDB so that the message queue is not flooded. This is implemented with a buffer of events which are considered by the EventStoreDB to be in-flight when they are sent to the client. Events remain in-flight until they are ack/3 -ed, nack/4 -ed, or until the :message_timeout duration is exceeded. If a client ack/3 s a message, the EventStoreDB will send a new message if any are available. The in-flight buffer size is controllable per subscriber through :buffer_size . Note that :message_timeout applies to each event: if the :buffer_size is 5 and five events arrive simultaneously, the client has the duration :message_timeout to acknowledge all five events before they are considered stale and are automatically considered nack-ed by the EventStoreDB. The :buffer_size should align with the consumer's ability to batch process events. Delivery guarantees Persistent subscriptions provide at-least once delivery. Messages may be re-delivered under a few circumstances: Negatively acknowledging a message with nack/4 with the :action set to :retry will queue the message for re-delivery. A message may be handled successfully but not within the configured :message_timeout . If the server does not receive an ack/3 within the timeout, the message may be re-delivered. The acknowledgement from ack/3 may be lost. This can happen in a few cases: If the acknowledgement is sent and then a subscription is immediately cancelled (either explicitly with Spear.cancel_subscription/2 or if the subscription process terminates immediately after sending an ack), the EventStoreDB may discard the ack. This is because of a limitation in the protocol which conflates the closing of a subscription with the corruption of data being sent to the server. Subscription processes may wish to sleep between the last acknowledgement and exiting to reduce the chances of this happening. An unreliable network may drop the packet containing the acknowledgement. Re-delivered messages may arrive out-of-order. Cases of repeated delivery or out-of-order delivery should be handled at the application level. Also see the EventStoreDB Server docs on Persistent Subscriptions. Options :timeout - (default: 5_000 ms - 5s) the time to await a subscription confirmation from the EventStoreDB. :raw? - (default: false ) controls whether events are translated from low-level Spear.Records.Persistent.read_resp/0 records to Spear.Event.t/0 s. By default Spear.Event.t/0 s are sent to the subscriber. :credentials - (default: nil ) the credentials to use to connect to the subscription. When not specified, the connection-level credentials are used. Credentials must be a two-tuple {username, password} . :buffer_size - (default: 1 ) the number of events allowed to be sent to the client at a time. These events are considered in-flight. See the backpressure section above for more information. Examples iex&gt; Spear . connect_to_persistent_subscription ( conn , self ( ) , &quot;my_stream&quot; , &quot;my_group&quot; ) iex&gt; flush % Spear.Event { } :ok","ref":"Spear.html#connect_to_persistent_subscription/5","title":"Spear.connect_to_persistent_subscription/5","type":"function"},{"doc":"Creates a persistent subscription See Spear.PersistentSubscription.Settings.t/0 for more information. Note that persistent subscriptions to the :all stream with server-side filtering is a feature introduced in EventStoreDB v21.6.0. Attempting to use the :all stream on older EventStoreDB versions will fail. Options :from - the position or revision in the stream where the persistent subscription should start. This option may be :start or :end describing the beginning or end of the stream. When the stream_name is :all , this parameter describes the prepare and commit positions in the :all stream which can be found on any event emitted from a subscription to the :all stream. When the stream_name is not the :all stream, this option may be an integer representing the event number in the stream from which the subscription should start. This may be found on any Spear.Event.t/0 . This option may be passed a Spear.Event.t/0 , from which either the revision or position will be determined based on the stream name. This option overwrites the :revision field on the Spear.PersistentSubscription.Settings.t/0 type which is now deprecated. :filter - a filter to apply while reading from the :all stream. This option only applies when reading the :all stream. The same data structure works for regular and persistent subscriptions to the :all stream. See the Spear.Filter.t/0 documentation for more information. Remaining options are passed to request/5 . Examples iex&gt; Spear . create_persistent_subscription ( conn , &quot;my_stream&quot; , &quot;my_group&quot; , % Spear.PersistentSubscription.Settings { } ) :ok iex&gt; import Spear.Filter iex&gt; filter = ~f/My.Aggregate.A- My.Aggregate.B-/ps iex&gt; Spear . create_persistent_subscription ( conn , :all , &quot;my_all_group&quot; , % Spear.PersistentSubscription.Settings { } , filter : filter ) :ok","ref":"Spear.html#create_persistent_subscription/5","title":"Spear.create_persistent_subscription/5","type":"function"},{"doc":"Creates an EventStoreDB user Options All options are passed to Spear.request/5 . Examples iex&gt; Spear . create_user ( conn , &quot;Aladdin&quot; , &quot;aladdin&quot; , &quot;open sesame&quot; , [ &quot;$ops&quot; ] , credentials : { &quot;admin&quot; , &quot;changeit&quot; } ) :ok","ref":"Spear.html#create_user/6","title":"Spear.create_user/6","type":"function"},{"doc":"Deletes a persistent subscription from the EventStoreDB Persistent subscriptions are considered unique by their stream and group names together: you may define separate persistent subscriptions for the same stream with multiple groups or use the same group name for persistent subscriptions to multiple streams. A combination of stream name and group name together is considered unique though. Options Options are passed to request/5 . Examples iex&gt; Spear . delete_persistent_subscription ( conn , &quot;my_stream&quot; , &quot;MyGroup&quot; ) :ok","ref":"Spear.html#delete_persistent_subscription/4","title":"Spear.delete_persistent_subscription/4","type":"function"},{"doc":"Deletes an EventStoreDB stream EventStoreDB supports two kinds of stream deletions: soft-deletes and tombstones. By default this function will perform a soft-delete. Pass the tombstone?: true option to tombstone the stream. Soft-deletes make the events in the specified stream no longer accessible through reads. A scavenge operation will reclaim the disk space taken by any soft-deleted events. New events may be written to a soft-deleted stream. When reading soft-deleted streams, :from options of :start and :end will behave as expected, but all events in the stream will have revision numbers off-set by the number of deleted events. Tombstoned streams may not be written to ever again. Attempting to write to a tombstoned stream will fail with a gRPC :failed_precondition error iex&gt; [ Spear.Event . new ( &quot;delete_test&quot; , %{ } ) ] |&gt; Spear . append ( conn , &quot;delete_test_0&quot; ) :ok iex&gt; Spear . delete_stream ( conn , &quot;delete_test_0&quot; , tombstone? : true ) :ok iex&gt; [ Spear.Event . new ( &quot;delete_test&quot; , %{ } ) ] |&gt; Spear . append ( conn , &quot;delete_test_0&quot; ) { :error , % Spear.Grpc.Response { data : &quot;&quot; , message : &quot;Event stream &#39;delete_test_0&#39; is deleted.&quot; , status : :failed_precondition , status_code : 9 } } Options :tombstone? - (default: false ) controls whether the stream is soft-deleted or tombstoned. :timeout - (default: 5_000 - 5s) the time allowed to block while waiting for the EventStoreDB to delete the stream. :expect - (default: :any ) the expected state of the stream when performing the deletion. See append/4 and Spear.ExpectationViolation for more information. :credentials - (default: nil ) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details. Examples iex&gt; Spear . append ( events , conn , &quot;my_stream&quot; ) :ok iex&gt; Spear . delete_stream ( conn , &quot;my_stream&quot; ) :ok iex&gt; Spear . stream! ( conn , &quot;my_stream&quot; ) |&gt; Enum . to_list ( ) [ ]","ref":"Spear.html#delete_stream/3","title":"Spear.delete_stream/3","type":"function"},{"doc":"Deletes a user from the EventStoreDB EventStoreDB users are deleted by the login_name parameter as passed to Spear.create_user/6 . Options All options are passed to Spear.request/5 . Examples iex&gt; Spear . create_user ( conn , &quot;Aladdin&quot; , &quot;aladdin&quot; , &quot;open sesame&quot; , [ &quot;$ops&quot; ] , credentials : { &quot;admin&quot; , &quot;changeit&quot; } ) :ok iex&gt; Spear . delete_user ( conn , &quot;aladdin&quot; , credentials : { &quot;admin&quot; , &quot;changeit&quot; } ) :ok","ref":"Spear.html#delete_user/3","title":"Spear.delete_user/3","type":"function"},{"doc":"Disables a user's ability to make requests against the EventStoreDB This can be used in conjunction with Spear.enable_user/3 to temporarily deny access to a user as an alternative to deleting and creating the user. Enabling and disabling users does not require the password of the user: just that requestor to be in the $admins group. Options All options are passed to Spear.request/5 . Examples iex&gt; Spear . enable_user ( conn , &quot;aladdin&quot; ) :ok iex&gt; Spear . disable_user ( conn , &quot;aladdin&quot; ) :ok","ref":"Spear.html#disable_user/3","title":"Spear.disable_user/3","type":"function"},{"doc":"Enables a user to make requests against the EventStoreDB Disabling and enabling users are an alternative to repeatedly creating and deleting users and is suitable for when a user needs to be temporarily denied access. Options All options are passed to Spear.request/5 . Examples iex&gt; Spear . disable_user ( conn , &quot;aladdin&quot; ) :ok iex&gt; Spear . enable_user ( conn , &quot;aladdin&quot; ) :ok","ref":"Spear.html#enable_user/3","title":"Spear.enable_user/3","type":"function"},{"doc":"Gets information pertaining to a persistent subcription. Requires server version 22.6.0 or above. opts are passed to the underlying request. Examples iex&gt; Spear . get_persistent_subscription_info ( conn , &quot;accounts&quot; , &quot;subscription-group&quot; ) { :ok , % Spear.PersistentSubscription.Info { event_source : &quot;accounts&quot; , group_name : &quot;subscription-group&quot; , status : &quot;Live&quot; , average_per_second : 0 , total_items : 78 , count_since_last_measurement : 0 , last_checkpointed_event_position : &quot;31&quot; , last_known_event_position : &quot;36&quot; , start_from : &quot;0&quot; , message_timeout_milliseconds : 30000 , max_retry_count : 10 , live_buffer_size : 500 , buffer_size : 500 , read_batch_size : 20 , check_point_after_milliseconds : 2000 , min_check_point_count : 10 , max_check_point_count : 1000 , read_buffer_count : 0 , live_buffer_count : 36 , retry_buffer_count : 0 , total_in_flight_messages : 0 , outstanding_messages_count : 0 , named_consumer_strategy : :RoundRobin , max_subscriber_count : 0 , parked_message_count : 1 , connections : [ ] , extra_statistics? : false , resolve_link_tos? : false } }","ref":"Spear.html#get_persistent_subscription_info/4","title":"Spear.get_persistent_subscription_info/4","type":"function"},{"doc":"Determines the current version of the connected server This function is compatible with server version v21.10.0 and later. Options Options are passed to request/5 . Examples iex&gt; Spear . get_server_version ( conn ) { :ok , &quot;21.10.0&quot; }","ref":"Spear.html#get_server_version/2","title":"Spear.get_server_version/2","type":"function"},{"doc":"Queries the metadata for a stream Note that the stream argument is passed through meta_stream/1 before being read. It is not necessary to call that function on the stream name before passing it as stream . If no metadata has been set on a stream {:error, :unset} is returned. Options Under the hood, get_stream_metadata/3 uses read_stream/3 and all options are passed directly to that function. These options are overridden, however, and cannot be changed: :direction :from :max_count :raw? Examples iex&gt; Spear . get_stream_metadata ( conn , &quot;my_stream&quot; ) { :error , :unset } iex&gt; Spear . get_stream_metadata ( conn , &quot;some_stream_with_max_count&quot; ) { :ok , % Spear.StreamMetadata { max_count : 50_000 , .. } }","ref":"Spear.html#get_stream_metadata/3","title":"Spear.get_stream_metadata/3","type":"function"},{"doc":"Requests the available server RPCs This function is compatible with server version v21.10.0 and later. Options Options are passed to request/5 . Examples iex&gt; Spear . get_supported_rpcs ( conn ) { :ok , [ % Spear.SupportedRpc { features : [ &quot;stream&quot; , &quot;all&quot; ] , rpc : &quot;create&quot; , service : &quot;event_store.client.persistent_subscriptions.persistentsubscriptions&quot; } , % Spear.SupportedRpc { features : [ &quot;stream&quot; , &quot;all&quot; ] , rpc : &quot;update&quot; , service : &quot;event_store.client.persistent_subscriptions.persistentsubscriptions&quot; } , .. ] }","ref":"Spear.html#get_supported_rpcs/2","title":"Spear.get_supported_rpcs/2","type":"function"},{"doc":"Lists the currently existing persistent subscriptions Results are returned in an Enumerable.t/0 of Spear.PersistentSubscription.t/0 . Note that the :extra_statistics? field of settings is not determined by this function: :extra_statistics? will always be returned as nil in this function. This function works by reading the built-in $persistentSubscriptionConfig stream. This stream can be read normally to obtain additional information such as at timestamp for the last time the persistent subscription config was updated. Options Options are passed to read_stream/3 . :direction , :from , and :max_count are fixed and cannot be overridden. Examples iex&gt; Spear . create_persistent_subscription ( conn , &quot;my_stream&quot; , &quot;my_group&quot; , % Spear.PersistentSubscription.Settings { } ) :ok iex&gt; { :ok , subscriptions } = Spear . list_persistent_subscriptions ( conn ) iex&gt; subscriptions |&gt; Enum . to_list ( ) [ % Spear.PersistentSubscription { group_name : &quot;my_group&quot; , settings : % Spear.PersistentSubscription.Settings { checkpoint_after : 3000 , extra_statistics? : nil , history_buffer_size : 300 , live_buffer_size : 100 , max_checkpoint_count : 100 , max_retry_count : 10 , max_subscriber_count : 1 , message_timeout : 5000 , min_checkpoint_count : 1 , named_consumer_strategy : :RoundRobin , read_batch_size : 100 , resolve_links? : true , revision : 0 } , stream_name : &quot;my_stream&quot; } ]","ref":"Spear.html#list_persistent_subscriptions/2","title":"Spear.list_persistent_subscriptions/2","type":"function"},{"doc":"Requests that the indices be merged See the EventStoreDB documentation for more information. A user does not need to be in $ops or any group to initiate this request. Options Options are passed to request/5 . Examples iex&gt; Spear . merge_indexes ( conn ) :ok","ref":"Spear.html#merge_indexes/2","title":"Spear.merge_indexes/2","type":"function"},{"doc":"Determines the metadata stream for any given stream Meta streams are used by the EventStoreDB to store some internal information about a stream, and to configure features such setting time-to-lives for events or streams. Examples iex&gt; Spear . meta_stream ( &quot;es_supported_clients&quot; ) &quot;$$es_supported_clients&quot;","ref":"Spear.html#meta_stream/1","title":"Spear.meta_stream/1","type":"function"},{"doc":"Negatively acknowldeges a persistent subscription event Nacking is the opposite of ack/3 ing: it tells the EventStoreDB that the event should not be considered processed. Options :action - (default: :retry ) controls the action the EventStoreDB should take about the event. See Spear.PersistentSubscription.nack_action/0 for a full description. :reason - (default: &quot;&quot; ) a description of why the event is being nacked Examples # some stream with 3 events stream_name = &quot;my_stream&quot; group_name = &quot;spear_iex&quot; settings = % Spear.PersistentSubscription.Settings { } get_event_and_ack = fn conn , sub , action -&gt; receive do % Spear.Event { } = event -&gt; :ok = Spear . nack ( conn , sub , event , action : action ) event after 3_000 -&gt; :no_events end end iex&gt; Spear . create_persistent_subscription ( conn , stream_name , group_name , settings ) :ok iex&gt; { :ok , sub } = Spear . connect_to_persistent_subscription ( conn , self ( ) , stream_name , group_name ) iex&gt; get_event_and_nack . ( conn , sub , :retry ) % Spear.Event { .. } # event 0 iex&gt; get_event_and_nack . ( conn , sub , :retry ) % Spear.Event { .. } # event 0 iex&gt; get_event_and_nack . ( conn , sub , :park ) # park event 0 and move on % Spear.Event { .. } # event 0 iex&gt; get_event_and_nack . ( conn , sub , :skip ) # skip event 1 % Spear.Event { .. } # event 1 iex&gt; get_event_and_nack . ( conn , sub , :skip ) # skip event 2 % Spear.Event { .. } # event 2 iex&gt; get_event_and_nack . ( conn , sub , :skip ) :no_events iex&gt; Spear . cancel_subscription ( conn , sub ) :ok","ref":"Spear.html#nack/4","title":"Spear.nack/4","type":"function"},{"doc":"Returns the parked events stream for a persistent subscription stream and group. If an event is negatively acknowledged and parked, the persistent subscription will add it to the park stream for the given stream+group combination. It can be useful to read this stream to determine if there are any parked messages. Examples iex&gt; Spear . park_stream ( &quot;MyStream&quot; , &quot;MyGroup&quot; ) &quot;$persistentsubscription-MyStream::MyGroup-parked&quot;","ref":"Spear.html#park_stream/2","title":"Spear.park_stream/2","type":"function"},{"doc":"Parses an EventStoreDB timestamp into a DateTime.t() in UTC time. Examples iex&gt; Spear . parse_stamp ( 16187636458580612 ) { :ok , ~U[2021-04-18 16:34:05.858061Z] }","ref":"Spear.html#parse_stamp/1","title":"Spear.parse_stamp/1","type":"function"},{"doc":"Pings a connection This can be used to ensure that the connection process is alive, or to roughly measure the latency between the connection process and EventStoreDB. Examples iex&gt; Spear . ping ( conn ) :pong","ref":"Spear.html#ping/2","title":"Spear.ping/2","type":"function"},{"doc":"Reads a chunk of events from an EventStoreDB stream into an enumerable Unlike stream!/3 , this function will only read one chunk of events at a time specified by the :max_count option. This function also does not raise in cases of error, instead returning an ok- or error-tuple. If the stream_name EventStoreDB stream does not exist (is empty) and the gRPC request succeeds for this function, {:ok, []} will be returned. Options :from - (default: :start ) the EventStoreDB stream revision from which to read. Valid values include :start , :end , any non-negative integer representing the event number revision in the stream and events. Event numbers are inclusive (e.g. reading from 0 will first return the event with revision 0 in the stream, if one exists). :start and :end are treated as inclusive (e.g. :start will return the first event in the stream). Events (either Spear.Event or ReadResp records) can also be supplied and will be treated as inclusive. :direction - (default: :forwards ) the direction in which to read the EventStoreDB stream. Valid values include :forwards and :backwards . Reading the EventStoreDB stream forwards will return events in the order in which they were written to the EventStoreDB; reading backwards will return events in the opposite order. :filter - (default: nil ) the server-side filter to apply. This option is only valid if the stream_name is :all . See Spear.Filter for more information. This feature requires EventStoreDB vTODO+. :resolve_links? - (default: true ) whether or not to request that link references be resolved. See the moduledocs for more information about link resolution. :max_count - (default: 42 ) the maximum number of events to read from the EventStoreDB stream. Any positive integer is valid. Even if the stream is longer than this :max_count option, only :max_count events will be returned from this function. :infinity is not a valid value for :max_count . Use stream!/3 for an enumerable which reads an EventStoreDB stream in its entirety in chunked network requests. :timeout - (default: 5_000 - 5s) the time allowed for the read of the single chunk of events in the EventStoreDB stream. Note that the gRPC request which reads events from the EventStoreDB is front-loaded in this function: the :timeout covers the time it takes to read the events. The timeout may be exceeded :raw?: - (default: false ) controls whether or not the enumerable event_stream is decoded to Spear.Event structs from their raw ReadResp output. Setting raw?: true prevents this transformation and leaves each event as a Spear.Records.Streams.read_resp/0 record. See Spear.Event.from_read_response/2 for more information. :credentials - (default: nil ) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details. Timing and Timeouts The gRPC request which reads events from the EventStoreDB is front-loaded in this function: this function returns immediately after receiving all data off the wire from the network request. This means that the :timeout option covers the gRPC request and response time but not any time spend decoding the response (see the Enumeration Characteristics section below for more details on how the enumerable decodes messages). The default timeout of 5s may not be enough time in cases of either reading very large numbers of events or reading events with very large bodies. Note that up to the :max_count of events is returned from this call depending on however many events are in the EventStoreDB stream being read. When tuning the :timeout option, make sure to test against a stream which is at least as long as :max_count events. Enumeration Characteristics The event_stream Enumerable.t/0 returned in the success case of this function is a wrapper around the bytes received from the gRPC response. Note that when the {:ok, event_stream} is returned, the gRPC request has already concluded. This offers only marginal performance improvement: an enumerable is returned mostly for consistency in the Spear API. Examples # say we have 5 events in the stream &quot;es_supported_clients&quot; iex&gt; { :ok , events } = Spear . read_stream ( conn , &quot;es_supported_clients&quot; , max_count : 2 ) iex&gt; events |&gt; Enum . count ( ) 2 iex&gt; { :ok , events } = Spear . read_stream ( conn , &quot;es_supported_clients&quot; , max_count : 10 ) iex&gt; events |&gt; Enum . count ( ) 5 iex&gt; events |&gt; Enum . take ( 1 ) [ % Spear.Event { body : %{ &quot;languages&quot; =&gt; [ &quot;typescript&quot; , &quot;javascript&quot; ] , &quot;runtime&quot; =&gt; &quot;NodeJS&quot; } , id : &quot;1fc908c1-af32-4d06-a9bd-3bf86a833fdf&quot; , metadata : %{ .. } , type : &quot;grpc-client&quot; } ]","ref":"Spear.html#read_stream/3","title":"Spear.read_stream/3","type":"function"},{"doc":"Requests that the server replays any messages parked for a persistent subscription stream and group. Options :stop_at - the number of messages to request be replayed. If not specified, the number of messages is not limited. Remaining options are passed to Spear.request/5 . Examples iex&gt; Spear . create_persistent_subscription ( conn , &quot;my_stream&quot; , &quot;my_group&quot; , % Spear.PersistentSubscription.Settings { } ) # ... nack some events with the `:park` action ... iex&gt; Spear . replay_parked ( conn , &quot;my_stream&quot; , &quot;my_group&quot; ) :ok # ... parked messages are re-delivered ...","ref":"Spear.html#replay_parked_messages/4","title":"Spear.replay_parked_messages/4","type":"function"},{"doc":"Performs a generic request synchronously This is appropriate for many operations across the Users, Streams, and Operations APIs but not suitable for Spear.subscribe/4 or the Persistent Subscriptions API. message must be an enumeration of records as created by the Record Interfaces. Lazy stream enumerations are allowed and are not run until each element is serialized over the wire. This function is mostly used under-the-hood to implement functions in Spear such as Spear.create_user/5 , but may be used generically. Options :timeout - (default: 5_000 ms - 5s) the GenServer timeout: the maximum time allowed to wait for this request to complete. :credentials - (default: nil ) the username and password to use to make the request. Overrides the connection-level credentials if provided. Connection-level credentials are used as the default if not provided. Examples iex&gt; alias Spear.Records.Users iex&gt; require Users iex&gt; message = Users . enable_req ( options : Users . enable_req_options ( login_name : &quot;my_user&quot; ) ) iex&gt; Spear . request ( conn , Users , :Enable , [ message ] , credentials : { &quot;admin&quot; , &quot;changeit&quot; } ) { :ok , Users . enable_resp ( ) }","ref":"Spear.html#request/5","title":"Spear.request/5","type":"function"},{"doc":"Resets a user's password This can be only requested by a user in the $admins group. The current password is not passed in this request, so this function is suitable for setting a new password when the current password is lost. Options All options are passed to Spear.request/5 . Examples iex&gt; Spear . create_user ( conn , &quot;Aladdin&quot; , &quot;aladdin&quot; , &quot;changeit&quot; , [ &quot;$ops&quot; ] ) :ok iex&gt; Spear . reset_user_password ( conn , &quot;aladdin&quot; , &quot;open sesame&quot; , credentials : { &quot;admin&quot; , &quot;changeit&quot; } ) :ok","ref":"Spear.html#reset_user_password/4","title":"Spear.reset_user_password/4","type":"function"},{"doc":"Requests that the currently connected node resign its leadership role See the EventStoreDB documentation for more information. A user does not need to be in $ops or any group to initiate this request. Options Options are passed to request/5 . Examples iex&gt; Spear . resign_node ( conn ) :ok","ref":"Spear.html#resign_node/2","title":"Spear.resign_node/2","type":"function"},{"doc":"Restarts the persistent subscription subsystem on the EventStoreDB server.","ref":"Spear.html#restart_persistent_subscription_subsystem/2","title":"Spear.restart_persistent_subscription_subsystem/2","type":"function"},{"doc":"Restarts all persistent subscriptions See the EventStoreDB documentation for more information. A user does not need to be in $ops or any group to initiate this request. Options Options are passed to request/5 . Examples iex&gt; Spear . restart_persistent_subscriptions ( conn ) :ok","ref":"Spear.html#restart_persistent_subscriptions/2","title":"Spear.restart_persistent_subscriptions/2","type":"function"},{"doc":"Produces the scavenge stream for a scavenge ID start_scavenge/2 begins an asynchronous scavenge operation since scavenges may be time consuming. In order to check the progress of a running scavenge, one may read the scavenge stream with read_stream/3 or stream!/3 or subscribe to updates on the scavenge with subscribe/4 . Examples iex&gt; { :ok , scavenge } = Spear . start_scavenge ( conn ) { :ok , % Spear.Scavenge { id : &quot;d2897ba8-2f0c-4fc4-bb25-798ba75f3562&quot; , result : :Started } } iex&gt; Spear . scavenge_stream ( scavenge ) &quot;$scavenges-d2897ba8-2f0c-4fc4-bb25-798ba75f3562&quot;","ref":"Spear.html#scavenge_stream/1","title":"Spear.scavenge_stream/1","type":"function"},{"doc":"Sets the global stream ACL This function appends metadata to the $streams EventStoreDB stream detailing how the EventStoreDB should allow access to user and system streams (with the user_acl and system_acl arguments, respectively). See the security guide for more information. Options :json_encode! - (default: Jason.encode!/1 ) a 1-arity JSON encoding function used to serialize the event. This event must be JSON encoded in order for the EventStoreDB to consider it valid. Remaining options are passed to Spear.append/4 . The :expect option will be applied to the $streams system stream, so one could attempt to set the initial ACL by passing expect: :empty . Examples This recreates the default ACL: iex&gt; Spear . set_global_acl ( conn , Spear.Acl . allow_all ( ) , Spear.Acl . admins_only ( ) ) :ok","ref":"Spear.html#set_global_acl/4","title":"Spear.set_global_acl/4","type":"function"},{"doc":"Sets the node priority number See the EventStoreDB documentation for more information. A user does not need to be in $ops or any group to initiate this request. Options Options are passed to request/5 . Examples iex&gt; Spear . set_node_priority ( conn , 1 ) :ok","ref":"Spear.html#set_node_priority/3","title":"Spear.set_node_priority/3","type":"function"},{"doc":"Sets a stream's metadata Note that the stream argument is passed through meta_stream/1 before being read. It is not necessary to call that function on the stream name before passing it as stream . Options This function uses append/4 under the hood. All options are passed to the opts argument of append/4 . Examples # only allow admins to read, write, and delete the stream (or stream metadata) iex&gt; metadata = % Spear.StreamMetadata { acl : Spear.Acl . admins_only ( ) } iex&gt; Spear . set_stream_metadata ( conn , stream , metadata ) :ok","ref":"Spear.html#set_stream_metadata/4","title":"Spear.set_stream_metadata/4","type":"function"},{"doc":"Shuts down the connected EventStoreDB The user performing the shutdown (either the connection credentials or credentials passed by the :credentials option) must at least be in the $ops group. $admins permissions are a superset of $ops . Options Options are passed to request/5 . Examples iex&gt; Spear . shutdown ( conn ) :ok iex&gt; Spear . ping ( conn ) { :error , :closed } iex&gt; Spear . shutdown ( conn , credentials : { &quot;some_non_ops_user&quot; , &quot;changeit&quot; } ) { :error , % Spear.Grpc.Response { data : &quot;&quot; , message : &quot;Access Denied&quot; , status : :permission_denied , status_code : 7 } } iex&gt; Spear . ping ( conn ) :pong","ref":"Spear.html#shutdown/2","title":"Spear.shutdown/2","type":"function"},{"doc":"Requests that a scavenge be started Scavenges are disk-space reclaiming operations run on the EventStoreDB server. Options :thread_count - (default: 1 ) the number of threads to use for the scavenge process. Scavenging can be resource intensive. Setting this to a low thread count can lower the impact on the server's resources. :start_from_chunk - (default: 0 ) the chunk number to start the scavenge from. Generally this is only useful if a prior scavenge has failed on a certain chunk. Remaining options are passed to request/5 . Examples iex&gt; Spear . start_scavenge ( conn ) { :ok , % Spear.Scavenge { id : &quot;d2897ba8-2f0c-4fc4-bb25-798ba75f3562&quot; , result : :Started } }","ref":"Spear.html#start_scavenge/2","title":"Spear.start_scavenge/2","type":"function"},{"doc":"Stops a running scavenge Options All options are passed to request/5 . Examples iex&gt; { :ok , scavenge } = Spear . start_scavenge ( conn ) iex&gt; Spear . stop_scavenge ( conn , scavenge . id ) { :ok , % Spear.Scavenge { id : &quot;d2897ba8-2f0c-4fc4-bb25-798ba75f3562&quot; , result : :Stopped } }","ref":"Spear.html#stop_scavenge/3","title":"Spear.stop_scavenge/3","type":"function"},{"doc":"Collects an EventStoreDB stream into an enumerable This function may raise in cases where the gRPC requests fail to read events from the EventStoreDB (in cases of timeout or unavailability). This function does not raise if a stream does not exist (is empty), instead returning an empty enumerable [] . connection may be any valid GenServer name (including PIDs) for a process running the Spear.Connection GenServer. stream_name can be any stream, existing or not, including projected streams such as category streams or event-type streams. The :all atom may be passed as stream_name to read all events in the EventStoreDB. Options :from - (default: :start ) the EventStoreDB stream revision from which to read. Valid values include :start , :end , any non-negative integer representing the event number revision in the stream and events. Event numbers are inclusive (e.g. reading from 0 will first return the event with revision 0 in the stream, if one exists). :start and :end are treated as inclusive (e.g. :start will return the first event in the stream). Events (either Spear.Event or ReadResp records) can also be supplied and will be treated as inclusive. :direction - (default: :forwards ) the direction in which to read the EventStoreDB stream. Valid values include :forwards and :backwards . Reading the EventStoreDB stream forwards will return events in the order in which they were written to the EventStoreDB; reading backwards will return events in the opposite order. :filter - (default: nil ) the server-side filter to apply. This option is only valid if the stream_name is :all . See Spear.Filter for more information. This feature requires EventStoreDB vTODO+. :resolve_links? - (default: true ) whether or not to request that link references be resolved. See the moduledocs for more information about link resolution. :chunk_size - (default: 128 ) the number of events to read from the EventStoreDB at a time. Any positive integer is valid. See the enumeration characteristics section below for more information about how :chunk_size works and how to tune it. :timeout - (default: 5_000 - 5s) the time allowed for the read of a single chunk of events in the EventStoreDB stream. This time is not cumulative: an EventStoreDB stream 100 events long which takes 5s to read each chunk may be read in chunks of 20 events culumaltively in 25s. A timeout of 5_001 ms would not raise a timeout error in that scenario (assuming the chunk read consistently takes &lt;= 5_000 ms). :raw?: - (default: false ) controls whether or not the enumerable event_stream is decoded to Spear.Event structs from their raw Spear.Records.Streams.read_resp/0 output. Setting raw?: true prevents this transformation and leaves each event as a ReadResp record. See Spear.Event.from_read_response/2 for more information. :credentials - (default: nil ) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details. Enumeration Characteristics The event_stream Enumerable.t/0 returned by this function initially contains a buffer of bytes from the first read of the stream stream_name . This buffer potentially contains up to :chunk_size messages when run. The enumerable is written as a formula which abstracts away the chunking nature of the gRPC requests, however, so even though the EventStoreDB stream is read in chunks (per the :chunk_size option), the entire EventStoreDB stream can be read by running the enumeration (e.g. with Enum.to_list/1 ). Note that the stream will make a gRPC request to read more events whenever the buffer runs dry with up to :chunk_size messages filling the buffer on each request. :chunk_size is difficult to tune as it causes a tradeoff between (gRPC) request duration and number of messages added to the buffer. A higher :chunk_size may hydrate the buffer with more events and reduce the number of gRPC requests needed to read an entire stream, but it also increases the number of messages that will be sent over the network per request which could decrease reliability. Generally speaking, a lower :chunk_size is appropriate for streams in which the events are large and a higher :chunk_size is appropriate for streams with many small events. Manual tuning and trial-and-error can be used to find a performant :chunk_size setting for any individual environment. Examples iex&gt; Spear . stream! ( MyConnection , &quot;es_supported_clients&quot; , chunk_size : 1 ) |&gt; Enum . take ( 1 ) [ % Spear.Event { body : %{ &quot;languages&quot; =&gt; [ &quot;typescript&quot; , &quot;javascript&quot; ] , &quot;runtime&quot; =&gt; &quot;NodeJS&quot; } , id : &quot;1fc908c1-af32-4d06-a9bd-3bf86a833fdf&quot; , metadata : %{ .. } , type : &quot;grpc-client&quot; } ] # say we have 5 events in the &quot;es_supported_clients&quot; stream iex&gt; Spear . stream! ( MyConnection , &quot;es_supported_clients&quot; , chunk_size : 3 ) |&gt; Enum . count ( ) 5","ref":"Spear.html#stream!/3","title":"Spear.stream!/3","type":"function"},{"doc":"Subscribes a process to an EventStoreDB stream Unlike read_stream/3 or stream!/3 , this function does not return an enumerable. Instead the subscriber process is signed up to receive messages for subscription events. Events are emitted in order as info messages with the signature Spear.Event . t ( ) | Spear.Filter.Checkpoint . t ( ) or if the raw?: true option is provided, Spear.Records.Streams.read_resp/0 records will be returned in the shape of { subscription :: reference ( ) , Spear.Records.Streams . read_resp ( ) } This function will block the caller until the subscription has been confirmed by the EventStoreDB. When the subscription is terminated, the subscription process will receive a message in the form of {:eos, subscription, reason} . {:eos, subscription, :closed} is emitted when the connection between EventStoreDB and subscriber is severed and {:eos, subscription, :dropped} is emitted when the EventStoreDB explicitly drops a subscription. If this message is received, the subscription is considered to be concluded and the subscription process must re-subscribe from the last received event or checkpoint to resume the subscription. subscription is the reference returned by this function. Events can be correlated to their subscription via the subscription reference returned by this function. The subscription reference is included in Spear.Event.metadata.subscription , Spear.Filter.Checkpoint.subscription , and in the {:eos, subscription, reason} tuples as noted above. Subscriptions can be gracefully shut down with Spear.cancel_subscription/3 . The subscription will be cancelled by the connection process if the subscriber process exits. Options :from - (default: :start ) the EventStoreDB stream revision from which to read. Valid values include :start , :end , any non-negative integer representing the event number revision in the stream and events. Event numbers are exclusive (e.g. reading from 0 will first return the event numbered 1 in the stream, if one exists). :start and :end are treated as inclusive (e.g. :start will return the first event in the stream). Events and checkpoints ( Spear.Event.t/0 , ReadResp records, or Spear.Filter.Checkpoint.t/0 ) can also be supplied and will be treated as exclusive. :filter - (default: nil ) the server-side filter to apply. This option is only valid if the stream_name is :all . See Spear.Filter for more information. :resolve_links? - (default: true ) whether or not to request that link references be resolved. See the moduledocs for more information about link resolution. :timeout - (default: 5_000 ) the time to wait for the EventStoreDB to confirm the subscription request. :raw? - (default: false ) controls whether the events are sent as raw ReadResp records or decoded into Spear.Event.t/0 s :credentials - (default: nil ) a two-tuple {username, password} to use as credentials for the request. This option overrides any credentials set in the connection configuration, if present. See the Security guide for more details. Examples # say there are 3 events in the EventStoreDB stream &quot;my_stream&quot; iex&gt; { :ok , sub } = Spear . subscribe ( conn , self ( ) , &quot;my_stream&quot; , from : 0 ) { :ok , # Reference &lt; 0.1160763861 . 3015180291.51238 &gt; } iex&gt; flush % Spear.Event { } # second event % Spear.Event { } # third event :ok iex&gt; Spear . cancel_subscription ( conn , sub ) :ok iex&gt; { :ok , sub } = Spear . subscribe ( conn , self ( ) , :all , filter : Spear.Filter . exclude_system_events ( ) ) iex&gt; flush % Spear.Filter.Checkpoint { } % Spear.Filter.Checkpoint { } % Spear.Event { } % Spear.Event { } % Spear.Filter.Checkpoint { } % Spear.Event { } % Spear.Filter.Checkpoint { } :ok iex&gt; GenServer . call ( conn , :close ) { :ok , :closed } iex&gt; flush { :eos , # Reference &lt; 0.1160763861 . 3015180291.51238 &gt; , :closed }","ref":"Spear.html#subscribe/4","title":"Spear.subscribe/4","type":"function"},{"doc":"Subscribes a process to stats updates from the EventStoreDB This function subscribes a process in the same way as subscribe/4 : the function will return a reference representing the subscription and the stats messages will be sent to the subscriber process with send/2 . This subscription can be cancelled with cancel_subscription/3 . This functionality was added to EventStoreDB in release v21.6.0. Prior EventStoreDB versions will throw a GRPC error when attempting to use this function. Options :interval - (default: 5_000 - 5 seconds) the interval after which a new stats message should be sent. By default, stats messages arrive every five seconds. :use_metadata? - (default: true ) undocumented option. See the EventStoreDB implementation for more information. :timeout - (default: 5_000 - 5 seconds) the GenServer timeout to use when requesting a subscription to stats :raw? - (default: false ) whether to emit the stats messages as 'raw' Spear.Records.Monitoring.stats_resp/0 records in a tuple of {subscription :: reference(), Spear.Records.Monitoring.stats_resp()} . By default, stats messages are returned as maps. :credentials - (default: nil ) credentials to use to perform this subscription request. Examples iex&gt; Spear . subscribe_to_stats ( conn , self ( ) ) { :ok , # Reference &lt; 0.359109646 . 3547594759.216222 &gt; } iex&gt; flush ( ) %{ &quot;es-queue-Projection Core #2-length&quot; =&gt; &quot;0&quot; , &quot;es-queue-Worker #1-lengthLifetimePeak&quot; =&gt; &quot;0&quot; , &quot;es-queue-Worker #3-lengthCurrentTryPeak&quot; =&gt; &quot;0&quot; , &quot;es-queue-StorageReaderQueue #9-avgProcessingTime&quot; =&gt; &quot;0&quot; , &quot;es-queue-StorageReaderQueue #6-idleTimePercent&quot; =&gt; &quot;100&quot; , .. }","ref":"Spear.html#subscribe_to_stats/3","title":"Spear.subscribe_to_stats/3","type":"function"},{"doc":"Updates an existing persistent subscription See Spear.PersistentSubscription.Settings.t/0 for more information. Note that persistent subscriptions to the :all stream with server-side filtering is a feature introduced in EventStoreDB v21.6.0. Attempting to use the :all stream on older EventStoreDB versions will fail. Options Options are passed to request/5 . Examples iex&gt; Spear . update_persistent_subscription ( conn , &quot;my_stream&quot; , &quot;my_group&quot; , % Spear.PersistentSubscription.Settings { } ) :ok","ref":"Spear.html#update_persistent_subscription/5","title":"Spear.update_persistent_subscription/5","type":"function"},{"doc":"Updates an existing EventStoreDB user Options All options are passed to Spear.request/5 . Examples iex&gt; Spear . create_user ( conn , &quot;Aladdin&quot; , &quot;aladdin&quot; , &quot;open sesame&quot; , [ &quot;$ops&quot; ] , credentials : { &quot;admin&quot; , &quot;changeit&quot; } ) :ok iex&gt; Spear . update_user ( conn , &quot;Aladdin&quot; , &quot;aladdin&quot; , &quot;open sesame&quot; , [ &quot;$admins&quot; ] , credentials : { &quot;admin&quot; , &quot;changeit&quot; } ) :ok","ref":"Spear.html#update_user/6","title":"Spear.update_user/6","type":"function"},{"doc":"Fetches details about an EventStoreDB user Options All options are passed to Spear.request/5 . Examples iex&gt; Spear . create_user ( conn , &quot;Aladdin&quot; , &quot;aladdin&quot; , &quot;open sesame&quot; , [ &quot;$ops&quot; ] ) :ok iex&gt; Spear . user_details ( conn , &quot;aladdin&quot; ) { :ok , % Spear.User { enabled? : true , full_name : &quot;Aladdin&quot; , groups : [ &quot;$ops&quot; ] , last_updated : ~U[2021-04-18 16:48:38.583313Z] , login_name : &quot;aladdin&quot; } }","ref":"Spear.html#user_details/3","title":"Spear.user_details/3","type":"function"},{"doc":"A macro for defining a module which represents a connection to an EventStoreDB Like an Ecto.Repo or an Extreme client, this macro allows you to call functions on the module representing the connection instead of passing the connection pid or name as an argument to functions in Spear . This can be useful for client connections central to a service. All callbacks provided by this module are implemented on clients created with use Spear.Client . This pattern can be useful for applications which depend on an EventStoreDB connection similar to applications which depend on a (e.g.) PostgreSQL connection via Ecto.Repo . Writing clients as modules provides an intuitive &quot;is-a&quot; interface (e.g. &quot; MyEventStoreClient is an EventStoreDB client&quot;). Since this module defines a complete behaviour for a client module, mocking calls to the EventStoreDB is easy via a test dependency like the wonderful Dashbit library Mox . If a service does not know which connections it may need until runtime, the functions in Spear may be used with a connection processes spawned via DynamicSupervisor.start_child/2 instead. Configuration The __using__/1 macro defined by this module takes an optional :otp_app option. If provided, a helper clause for the start_link/1 callback will be injected which will fetch configuration for the connection from Application.get_env(otp_app, __MODULE__) , if available. Otherwise configuration for the connection may be passed through arguments to start_link/1 . Examples defmodule MyEventStoreClient do use Spear.Client , otp_app : :my_app end [ MyEventStoreClient ] |&gt; Supervisor . start_link ( strategy : :one_for_one ) iex&gt; MyEventStoreClient . stream! ( :all ) |&gt; Enum . take ( 1 ) [ % Spear.Event { } ]","ref":"Spear.Client.html","title":"Spear.Client","type":"behaviour"},{"doc":"A wrapper around Spear.ack/3","ref":"Spear.Client.html#c:ack/2","title":"Spear.Client.ack/2","type":"callback"},{"doc":"A wrapper around Spear.append/3","ref":"Spear.Client.html#c:append/2","title":"Spear.Client.append/2","type":"callback"},{"doc":"A wrapper around Spear.append/4","ref":"Spear.Client.html#c:append/3","title":"Spear.Client.append/3","type":"callback"},{"doc":"A wrapper around Spear.append_batch/4","ref":"Spear.Client.html#c:append_batch/3","title":"Spear.Client.append_batch/3","type":"callback"},{"doc":"A wrapper around Spear.append_batch/5","ref":"Spear.Client.html#c:append_batch/4","title":"Spear.Client.append_batch/4","type":"callback"},{"doc":"A wrapper around Spear.append_batch_stream/2","ref":"Spear.Client.html#c:append_batch_stream/1","title":"Spear.Client.append_batch_stream/1","type":"callback"},{"doc":"A wrapper around Spear.cancel_subscription/2","ref":"Spear.Client.html#c:cancel_subscription/1","title":"Spear.Client.cancel_subscription/1","type":"callback"},{"doc":"A wrapper around Spear.cancel_subscription/3","ref":"Spear.Client.html#c:cancel_subscription/2","title":"Spear.Client.cancel_subscription/2","type":"callback"},{"doc":"A wrapper around Spear.change_user_password/4","ref":"Spear.Client.html#c:change_user_password/3","title":"Spear.Client.change_user_password/3","type":"callback"},{"doc":"A wrapper around Spear.change_user_password/5","ref":"Spear.Client.html#c:change_user_password/4","title":"Spear.Client.change_user_password/4","type":"callback"},{"doc":"A wrapper around Spear.cluster_info/1","ref":"Spear.Client.html#c:cluster_info/0","title":"Spear.Client.cluster_info/0","type":"callback"},{"doc":"A wrapper around Spear.cluster_info/2","ref":"Spear.Client.html#c:cluster_info/1","title":"Spear.Client.cluster_info/1","type":"callback"},{"doc":"A wrapper around Spear.connect_to_persistent_subscription/4","ref":"Spear.Client.html#c:connect_to_persistent_subscription/3","title":"Spear.Client.connect_to_persistent_subscription/3","type":"callback"},{"doc":"A wrapper around Spear.connect_to_persistent_subscription/5","ref":"Spear.Client.html#c:connect_to_persistent_subscription/4","title":"Spear.Client.connect_to_persistent_subscription/4","type":"callback"},{"doc":"A wrapper around Spear.create_persistent_subscription/4","ref":"Spear.Client.html#c:create_persistent_subscription/3","title":"Spear.Client.create_persistent_subscription/3","type":"callback"},{"doc":"A wrapper around Spear.create_persistent_subscription/5","ref":"Spear.Client.html#c:create_persistent_subscription/4","title":"Spear.Client.create_persistent_subscription/4","type":"callback"},{"doc":"A wrapper around Spear.create_user/5","ref":"Spear.Client.html#c:create_user/4","title":"Spear.Client.create_user/4","type":"callback"},{"doc":"A wrapper around Spear.create_user/6","ref":"Spear.Client.html#c:create_user/5","title":"Spear.Client.create_user/5","type":"callback"},{"doc":"A wrapper around Spear.delete_persistent_subscription/3","ref":"Spear.Client.html#c:delete_persistent_subscription/2","title":"Spear.Client.delete_persistent_subscription/2","type":"callback"},{"doc":"A wrapper around Spear.delete_persistent_subscription/4","ref":"Spear.Client.html#c:delete_persistent_subscription/3","title":"Spear.Client.delete_persistent_subscription/3","type":"callback"},{"doc":"A wrapper around Spear.delete_stream/2","ref":"Spear.Client.html#c:delete_stream/1","title":"Spear.Client.delete_stream/1","type":"callback"},{"doc":"A wrapper around Spear.delete_stream/3","ref":"Spear.Client.html#c:delete_stream/2","title":"Spear.Client.delete_stream/2","type":"callback"},{"doc":"A wrapper around Spear.delete_user/2","ref":"Spear.Client.html#c:delete_user/1","title":"Spear.Client.delete_user/1","type":"callback"},{"doc":"A wrapper around Spear.delete_user/3","ref":"Spear.Client.html#c:delete_user/2","title":"Spear.Client.delete_user/2","type":"callback"},{"doc":"A wrapper around Spear.disable_user/2","ref":"Spear.Client.html#c:disable_user/1","title":"Spear.Client.disable_user/1","type":"callback"},{"doc":"A wrapper around Spear.disable_user/3","ref":"Spear.Client.html#c:disable_user/2","title":"Spear.Client.disable_user/2","type":"callback"},{"doc":"A wrapper around Spear.enable_user/2","ref":"Spear.Client.html#c:enable_user/1","title":"Spear.Client.enable_user/1","type":"callback"},{"doc":"A wrapper around Spear.enable_user/3","ref":"Spear.Client.html#c:enable_user/2","title":"Spear.Client.enable_user/2","type":"callback"},{"doc":"A wrapper around Spear.get_persistent_subscription_info/3","ref":"Spear.Client.html#c:get_persistent_subscription_info/2","title":"Spear.Client.get_persistent_subscription_info/2","type":"callback"},{"doc":"A wrapper around Spear.get_persistent_subscription_info/4","ref":"Spear.Client.html#c:get_persistent_subscription_info/3","title":"Spear.Client.get_persistent_subscription_info/3","type":"callback"},{"doc":"A wrapper around Spear.get_server_version/1","ref":"Spear.Client.html#c:get_server_version/0","title":"Spear.Client.get_server_version/0","type":"callback"},{"doc":"A wrapper around Spear.get_server_version/2","ref":"Spear.Client.html#c:get_server_version/1","title":"Spear.Client.get_server_version/1","type":"callback"},{"doc":"A wrapper around Spear.get_stream_metadata/2","ref":"Spear.Client.html#c:get_stream_metadata/1","title":"Spear.Client.get_stream_metadata/1","type":"callback"},{"doc":"A wrapper around Spear.get_stream_metadata/3","ref":"Spear.Client.html#c:get_stream_metadata/2","title":"Spear.Client.get_stream_metadata/2","type":"callback"},{"doc":"A wrapper around Spear.get_supported_rpcs/1","ref":"Spear.Client.html#c:get_supported_rpcs/0","title":"Spear.Client.get_supported_rpcs/0","type":"callback"},{"doc":"A wrapper around Spear.get_supported_rpcs/2","ref":"Spear.Client.html#c:get_supported_rpcs/1","title":"Spear.Client.get_supported_rpcs/1","type":"callback"},{"doc":"A wrapper around Spear.list_persistent_subscriptions/1","ref":"Spear.Client.html#c:list_persistent_subscriptions/0","title":"Spear.Client.list_persistent_subscriptions/0","type":"callback"},{"doc":"A wrapper around Spear.list_persistent_subscriptions/2","ref":"Spear.Client.html#c:list_persistent_subscriptions/1","title":"Spear.Client.list_persistent_subscriptions/1","type":"callback"},{"doc":"A wrapper around Spear.merge_indexes/1","ref":"Spear.Client.html#c:merge_indexes/0","title":"Spear.Client.merge_indexes/0","type":"callback"},{"doc":"A wrapper around Spear.merge_indexes/2","ref":"Spear.Client.html#c:merge_indexes/1","title":"Spear.Client.merge_indexes/1","type":"callback"},{"doc":"A wrapper around Spear.nack/3","ref":"Spear.Client.html#c:nack/2","title":"Spear.Client.nack/2","type":"callback"},{"doc":"A wrapper around Spear.nack/4","ref":"Spear.Client.html#c:nack/3","title":"Spear.Client.nack/3","type":"callback"},{"doc":"A wrapper around Spear.ping/1","ref":"Spear.Client.html#c:ping/0","title":"Spear.Client.ping/0","type":"callback"},{"doc":"A wrapper around Spear.ping/2","ref":"Spear.Client.html#c:ping/1","title":"Spear.Client.ping/1","type":"callback"},{"doc":"A wrapper around Spear.read_stream/2","ref":"Spear.Client.html#c:read_stream/1","title":"Spear.Client.read_stream/1","type":"callback"},{"doc":"A wrapper around Spear.read_stream/3","ref":"Spear.Client.html#c:read_stream/2","title":"Spear.Client.read_stream/2","type":"callback"},{"doc":"A wrapper around Spear.replay_parked_messages/3","ref":"Spear.Client.html#c:replay_parked_messages/2","title":"Spear.Client.replay_parked_messages/2","type":"callback"},{"doc":"A wrapper around Spear.replay_parked_messages/4","ref":"Spear.Client.html#c:replay_parked_messages/3","title":"Spear.Client.replay_parked_messages/3","type":"callback"},{"doc":"A wrapper around Spear.reset_user_password/3","ref":"Spear.Client.html#c:reset_user_password/2","title":"Spear.Client.reset_user_password/2","type":"callback"},{"doc":"A wrapper around Spear.reset_user_password/4","ref":"Spear.Client.html#c:reset_user_password/3","title":"Spear.Client.reset_user_password/3","type":"callback"},{"doc":"A wrapper around Spear.resign_node/1","ref":"Spear.Client.html#c:resign_node/0","title":"Spear.Client.resign_node/0","type":"callback"},{"doc":"A wrapper around Spear.resign_node/2","ref":"Spear.Client.html#c:resign_node/1","title":"Spear.Client.resign_node/1","type":"callback"},{"doc":"A wrapper around Spear.restart_persistent_subscription_subsystem/1","ref":"Spear.Client.html#c:restart_persistent_subscription_subsystem/0","title":"Spear.Client.restart_persistent_subscription_subsystem/0","type":"callback"},{"doc":"A wrapper around Spear.restart_persistent_subscription_subsystem/2","ref":"Spear.Client.html#c:restart_persistent_subscription_subsystem/1","title":"Spear.Client.restart_persistent_subscription_subsystem/1","type":"callback"},{"doc":"A wrapper around Spear.restart_persistent_subscriptions/1","ref":"Spear.Client.html#c:restart_persistent_subscriptions/0","title":"Spear.Client.restart_persistent_subscriptions/0","type":"callback"},{"doc":"A wrapper around Spear.restart_persistent_subscriptions/2","ref":"Spear.Client.html#c:restart_persistent_subscriptions/1","title":"Spear.Client.restart_persistent_subscriptions/1","type":"callback"},{"doc":"A wrapper around Spear.set_global_acl/3","ref":"Spear.Client.html#c:set_global_acl/2","title":"Spear.Client.set_global_acl/2","type":"callback"},{"doc":"A wrapper around Spear.set_global_acl/4","ref":"Spear.Client.html#c:set_global_acl/3","title":"Spear.Client.set_global_acl/3","type":"callback"},{"doc":"A wrapper around Spear.set_node_priority/2","ref":"Spear.Client.html#c:set_node_priority/1","title":"Spear.Client.set_node_priority/1","type":"callback"},{"doc":"A wrapper around Spear.set_node_priority/3","ref":"Spear.Client.html#c:set_node_priority/2","title":"Spear.Client.set_node_priority/2","type":"callback"},{"doc":"A wrapper around Spear.set_stream_metadata/3","ref":"Spear.Client.html#c:set_stream_metadata/2","title":"Spear.Client.set_stream_metadata/2","type":"callback"},{"doc":"A wrapper around Spear.set_stream_metadata/4","ref":"Spear.Client.html#c:set_stream_metadata/3","title":"Spear.Client.set_stream_metadata/3","type":"callback"},{"doc":"A wrapper around Spear.shutdown/1","ref":"Spear.Client.html#c:shutdown/0","title":"Spear.Client.shutdown/0","type":"callback"},{"doc":"A wrapper around Spear.shutdown/2","ref":"Spear.Client.html#c:shutdown/1","title":"Spear.Client.shutdown/1","type":"callback"},{"doc":"Starts a client as part of a supervision tree. This function is defaulted to pull connection parameters from application config or from the args Examples # lib/my_app/application.ex [ { MyEventStoreClient , connection_string : &quot;esdb://localhost:2113&quot; } , .. ] |&gt; Supervisor . start_link ( strategy : :one_for_one )","ref":"Spear.Client.html#c:start_link/1","title":"Spear.Client.start_link/1","type":"callback"},{"doc":"A wrapper around Spear.start_scavenge/1","ref":"Spear.Client.html#c:start_scavenge/0","title":"Spear.Client.start_scavenge/0","type":"callback"},{"doc":"A wrapper around Spear.start_scavenge/2","ref":"Spear.Client.html#c:start_scavenge/1","title":"Spear.Client.start_scavenge/1","type":"callback"},{"doc":"A wrapper around Spear.stop_scavenge/2","ref":"Spear.Client.html#c:stop_scavenge/1","title":"Spear.Client.stop_scavenge/1","type":"callback"},{"doc":"A wrapper around Spear.stop_scavenge/3","ref":"Spear.Client.html#c:stop_scavenge/2","title":"Spear.Client.stop_scavenge/2","type":"callback"},{"doc":"A wrapper around Spear.stream!/2","ref":"Spear.Client.html#c:stream!/1","title":"Spear.Client.stream!/1","type":"callback"},{"doc":"A wrapper around Spear.stream!/3","ref":"Spear.Client.html#c:stream!/2","title":"Spear.Client.stream!/2","type":"callback"},{"doc":"A wrapper around Spear.subscribe/3","ref":"Spear.Client.html#c:subscribe/2","title":"Spear.Client.subscribe/2","type":"callback"},{"doc":"A wrapper around Spear.subscribe/4","ref":"Spear.Client.html#c:subscribe/3","title":"Spear.Client.subscribe/3","type":"callback"},{"doc":"A wrapper around Spear.subscribe_to_stats/2","ref":"Spear.Client.html#c:subscribe_to_stats/1","title":"Spear.Client.subscribe_to_stats/1","type":"callback"},{"doc":"A wrapper around Spear.subscribe_to_stats/3","ref":"Spear.Client.html#c:subscribe_to_stats/2","title":"Spear.Client.subscribe_to_stats/2","type":"callback"},{"doc":"A wrapper around Spear.update_persistent_subscription/4","ref":"Spear.Client.html#c:update_persistent_subscription/3","title":"Spear.Client.update_persistent_subscription/3","type":"callback"},{"doc":"A wrapper around Spear.update_persistent_subscription/5","ref":"Spear.Client.html#c:update_persistent_subscription/4","title":"Spear.Client.update_persistent_subscription/4","type":"callback"},{"doc":"A wrapper around Spear.update_user/5","ref":"Spear.Client.html#c:update_user/4","title":"Spear.Client.update_user/4","type":"callback"},{"doc":"A wrapper around Spear.update_user/6","ref":"Spear.Client.html#c:update_user/5","title":"Spear.Client.update_user/5","type":"callback"},{"doc":"A wrapper around Spear.user_details/3","ref":"Spear.Client.html#c:user_details/1","title":"Spear.Client.user_details/1","type":"callback"},{"doc":"A wrapper around Spear.user_details/3","ref":"Spear.Client.html#c:user_details/2","title":"Spear.Client.user_details/2","type":"callback"},{"doc":"A GenServer which brokers a connection to an EventStoreDB Spear.Connection will attempt to connect immediately after GenServer init. Failures to connect will result in back-off retries in segments of 500ms. Any GenServer to a connection process may return {:error, :closed} if the connection process is alive but the HTTP2 connection to the EventStoreDB is not yet (re)established. Spear.Connection will automatically attempt to re-connect to the EventStoreDB if the connection is severed. Spear.Connection processes accept GenServer.call/3 s of :close to force a disconnect from an EventStoreDB and a subsequent GenServer.cast/2 of :connect to reconnect based on the configuration supplied at init-time. If configuration parameters must change between disconnects and reconnects, spawning and killing connections with a DynamicSupervisor is recommended. Configuration See the Spear.Connection.Configuration module for available configuration of connections. TLS/SSL configuration and credentials See the Security guide for information about certificates, credentials, and access control lists (ACLs). Keep-alive Spear and the EventStoreDB use gRPC keep-alive to ensure that any hung connections are noticed and restarted. EventStoreDB has its own configuration for keep-alive and each Spear client's configuration should not necessarily match the server configuration. With a :keep_alive_interval too low on the Spear-side and with very many connected clients, the keep-alive pings can effectively become a DDoS even while no clients perform any operations. This does not necessarily apply to the keep-alive settings in EventStoreDB: a client connects to a single EventStoreDB but an EventStoreDB may have hundreds or more clients connected at once. :keep_alive_interval does not express an interval in the way of :timer.send_interval/3 . Instead the keep-alive timer is optimized to reset upon any data received from the connection. This means that (assuming consistent network, which is generous) either the Spear client or EventStoreDB server will dominate the keep-alive ping communication, the driver of the conversation being which ever has the lowest keep-alive interval configured. For this reason, it is generally advisable to set the client keep-alive just higher than the server keep-alive, adding noise for network latency, since the client's keep-alive routine will only trigger when the server's keep-alive message is behind schedule. Note that there may not be much value in attempting to optimize the keep-alive settings unless the network is very unstable: keep-alive only has utility when the client, server, or network is seriously delayed or silently severed. Examples iex&gt; { :ok , conn } = Spear.Connection . start_link ( connection_string : &quot;esdb://localhost:2113&quot; ) iex&gt; Spear . stream! ( conn , &quot;es_supported_clients&quot; ) |&gt; Enum . take ( 3 ) [ % Spear.Event { } , % Spear.Event { } , % Spear.Event { } ]","ref":"Spear.Connection.html","title":"Spear.Connection","type":"module"},{"doc":"Declares whether an API+RPC combination is read-only or not Examples iex&gt; Spear.Connection . read_api? ( Spear.Records.Streams , :Read ) true iex&gt; Spear.Connection . read_api? ( Spear.Records.Streams , :Append ) false","ref":"Spear.Connection.html#read_api?/2","title":"Spear.Connection.read_api?/2","type":"function"},{"doc":"Returns the list of read-only APIs This list is used to determine which requests are allowed for read-only clients.","ref":"Spear.Connection.html#read_apis/0","title":"Spear.Connection.read_apis/0","type":"function"},{"doc":"Starts a connection process This function can be called directly in order to link it to the current process, but the more common workflow is to start a Spear.Connection GenServer as a part of a supervision tree. Examples E.g. in an application's supervision tree defined in lib/my_app/application.ex : children = [ { Spear.Connection , name : MyConnection , connection_string : &quot;esdb://localhost:2113&quot; } ] Supervisor . start_link ( children , strategy : :one_for_one )","ref":"Spear.Connection.html#start_link/1","title":"Spear.Connection.start_link/1","type":"function"},{"doc":"A connection process A connection process (either referred to as conn or connection in the documentation) may either be a PID or a name such as a module or otherwise atom. Examples iex&gt; { :ok , conn } = Spear.Connection . start_link ( connection_string : &quot;esdb://localhost:2113&quot; ) { :ok , # PID &lt; 0 . 225 . 0 &gt; } iex&gt; Spear . read_stream ( conn , &quot;es_supported_clients&quot; , max_count : 1 ) { :ok , # Stream &lt; [ enum : # Function &lt; 62.80860365 / 2 in Stream . unfold / 2 &gt; , funs : [ # Function &lt; 48.80860365 / 1 in Stream . map / 2 &gt; ] ] &gt; }","ref":"Spear.Connection.html#t:t/0","title":"Spear.Connection.t/0","type":"type"},{"doc":"A server-side filter to apply when reading events from an EventStoreDB Regular expressions Elixir's built-in Regex module and Kernel.sigil_r/2 use PCRE-compatible regular expressions, but from the EventStoreDB codebase it seems that at time of writing, filtering is done with C-sharp's System.Text.RegularExpressions built-in. C-sharp regular expressions diverge in syntax a bit from PCRE-compatible expressions, so mileage may vary when passing Elixir regular expressions. As an escape hatch, you may build a Spear.Filter.t/0 manually and use a String.t/0 as the :by field. This value will be untouched except for last-minute encoding to go over-the-wire to the server. % Spear.Filter { on : :stream_name , by : &quot;&lt;some-complicated-regex&gt;&quot; , checkpoint_after : 1024 } If possible, the list of prefixes should be used as the :by option as they are unambiguous. Checkpoints The EventStoreDB will emit checkpoint events to a subscriber regularly. This prevents a possible (and perhaps probable) scenario where the EventStoreDB contains many events the client is searching for a small number of events relative to the size of :all (and/or) the target events are sparsely spread throughout :all Under these conditions, the EventStoreDB may progress through :all quite a ways before finding an event. If the connection is severed between the client and server while the EventStoreDB is part-way through a large drought of targeted events, the server will need to re-seek through the drought when the client re-connects and passes an old :from option to Spear.subscribe/4 . These checkpoints will arrive in the mailbox of the subscriber process as Spear.Filter.Checkpoint.t/0 structs and may be used as a restore point by passing them to the :from option of Spear.subscribe/4 . For example, say we have a subscriber process which is a GenServer and some function save_checkpoint/1 which saves checkpoint information durably (to disk or a database for example). It will handle subscription events in its GenServer.handle_info/2 callback. defmodule MySubscriber do use GenServer alias Spear . { Event , Filter.Checkpoint } .. @impl GenServer def handle_info ( % Event { } = event , state ) do # .. handle the event event |&gt; Event . to_checkpoint ( ) |&gt; save_checkpoint ( ) { :noreply , state } end def handle_info ( % Checkpoint { } = checkpoint , state ) do save_checkpoint ( checkpoint ) { :noreply , state } end end Checkpoint Interval The EventStoreDB will send a checkpoint after filtering a configurable number of events. The :checkpoint_after field can be used to configure this behavior. Note that the :checkpoint_after is only allowed by the server to be a multiple of 32 . Other values will be rounded to the nearest multiple. The default is set at 1024 ( 32 * 32 ) in Spear but this is tunable per filter with checkpoint_after/2 , or by manually adjusting the :checkpoint_after field in this struct.","ref":"Spear.Filter.html","title":"Spear.Filter","type":"module"},{"doc":"Sets the checkpoint interval Examples iex&gt; import Spear.Filter iex&gt; checkpoint_after ( ~f/^[^ \\$ ].*/rs , 32 * 8 ) % Spear.Filter { by : ~r/^[^ \\$ ].*/ , checkpoint_after : 256 , on : :stream_name }","ref":"Spear.Filter.html#checkpoint_after/2","title":"Spear.Filter.checkpoint_after/2","type":"function"},{"doc":"Produces a filter which excludes system events This is a potentially common filter for subscribers reading from :all . The sigil_f/2 version is ~f/^[^ \\$ ].*/rs Examples iex&gt; Spear.Filter . exclude_system_events ( ) % Spear.Filter { by : ~r/^[^ \\$ ].*/ , checkpoint_after : 1024 , on : :stream_name }","ref":"Spear.Filter.html#exclude_system_events/0","title":"Spear.Filter.exclude_system_events/0","type":"function"},{"doc":"A sigil defining a filter, without escaping Works the same as sigil_f/2 but does not allow interpolation or escape sequences. Examples iex&gt; import Spear.Filter iex&gt; ~F/^[^\\$].*/rs % Spear.Filter { by : ~r/^[^ \\$ ].*/ , checkpoint_after : 1024 , on : :stream_name }","ref":"Spear.Filter.html#sigil_F/2","title":"Spear.Filter.sigil_F/2","type":"function"},{"doc":"A sigil defining short-hand notation for writing filters Filters may either filter on EventStoreDB stream name or event type and may either filter by a regular expression or a list of prefix strings. Modifiers This f sigil supports the following modifiers. (Note that modifiers are the suffix of the sigil. E.g. the i in ~r/hello/i is a modifier for the regex sigil that declares that the match is case-insensitive.) For the choice between stream-name and event-type filtering: s - filter on the stream name t - filter on the event type For the choice between prefixes and regular expressions: p - filter by a list of prefixes. If this option is passed the sigil body will be interpreted as a white-space separated list of prefixes similar to sigil_w/2 from the standard library r - filter using a regular expression Examples iex&gt; import Spear.Filter iex&gt; ~f/My.Aggregate.A- My.Aggregate.B-/ps % Spear.Filter { by : [ &quot;My.Aggregate.A-&quot; , &quot;My.Aggregate.B-&quot; ] , checkpoint_after : 1024 , on : :stream_name } iex&gt; ~f/^[^ \\$ ].*/rs % Spear.Filter { by : ~r/^[^ \\$ ].*/ , checkpoint_after : 1024 , on : :stream_name }","ref":"Spear.Filter.html#sigil_f/2","title":"Spear.Filter.sigil_f/2","type":"function"},{"doc":"A filter which can be applied to a subscription to trigger server-side result filtering This filter type is intended to be passed as the :filter option to Spear.subscribe/4 . Examples iex&gt; import Spear.Filter iex&gt; ~f/^[^ \\$ ].*/rs # exclude system events which start with &quot;$&quot; % Spear.Filter { by : ~r/^[^ \\$ ].*/ , checkpoint_after : 1024 , on : :stream_name }","ref":"Spear.Filter.html#t:t/0","title":"Spear.Filter.t/0","type":"type"},{"doc":"A struct representing information pertaining to a persistent subscription. Returned by Spear.get_persistent_subscription_info/4","ref":"Spear.PersistentSubscription.Info.html","title":"Spear.PersistentSubscription.Info","type":"module"},{"doc":"details of a persistent subscription. See the EventStoredDB for more details.","ref":"Spear.PersistentSubscription.Info.html#t:t/0","title":"Spear.PersistentSubscription.Info.t/0","type":"type"},{"doc":"A struct representing information pertaining to a connection established to a PersistentSubscription .","ref":"Spear.PersistentSubscription.Info.ConnectionInfo.html","title":"Spear.PersistentSubscription.Info.ConnectionInfo","type":"module"},{"doc":"Information for a connection to a persistent subscription. See the EventStoreDB documentation for more information","ref":"Spear.PersistentSubscription.Info.ConnectionInfo.html#t:t/0","title":"Spear.PersistentSubscription.Info.ConnectionInfo.t/0","type":"type"},{"doc":"A struct representing an observed measurement in a Spear.PersistentSubscription.Info.ConnectionInfo structure.","ref":"Spear.PersistentSubscription.Info.ConnectionInfo.Measurement.html","title":"Spear.PersistentSubscription.Info.ConnectionInfo.Measurement","type":"module"},{"doc":"key and value for an aobserved measurement","ref":"Spear.PersistentSubscription.Info.ConnectionInfo.Measurement.html#t:t/0","title":"Spear.PersistentSubscription.Info.ConnectionInfo.Measurement.t/0","type":"type"},{"doc":"A struct representing an access control list (ACL) See the Security guide for more information on ACLs","ref":"Spear.Acl.html","title":"Spear.Acl","type":"module"},{"doc":"Produces an ACL that only allows access to all resources to the $admins group Examples iex&gt; Spear.Acl . admins_only ( ) % Spear.Acl { delete : &quot;$admins&quot; , metadata_read : &quot;$admins&quot; , metadata_write : &quot;$admins&quot; , read : &quot;$admins&quot; , write : &quot;$admins&quot; }","ref":"Spear.Acl.html#admins_only/0","title":"Spear.Acl.admins_only/0","type":"function"},{"doc":"Produces an ACL that allows all users access to all resources Note that clients that do not provide credentials at all fall under the $all group. Examples iex&gt; Spear.Acl . allow_all ( ) % Spear.Acl { delete : &quot;$all&quot; , metadata_read : &quot;$all&quot; , metadata_write : &quot;$all&quot; , read : &quot;$all&quot; , write : &quot;$all&quot; }","ref":"Spear.Acl.html#allow_all/0","title":"Spear.Acl.allow_all/0","type":"function"},{"doc":"Converts an ACL struct to a map with the keys expected by the EventStoreDB This function is used internally by Spear.set_global_acl/4 to create a global ACL event body, but may be used to create an acl body on its own. Examples iex&gt; Spear.Acl . allow_all ( ) |&gt; Spear.Acl . to_map ( ) %{ &quot;$w&quot; =&gt; &quot;$all&quot; , &quot;$r&quot; =&gt; &quot;$all&quot; , &quot;$d&quot; =&gt; &quot;$all&quot; , &quot;$mw&quot; =&gt; &quot;$all&quot; , &quot;$mr&quot; =&gt; &quot;$all&quot; }","ref":"Spear.Acl.html#to_map/1","title":"Spear.Acl.to_map/1","type":"function"},{"doc":"An access control list (ACL) type See the Security guide for more information on ACLs ACLs may provide permissions for a single user/group or a list of user/groups. Examples iex&gt; Spear.Acl . allow_all ( ) % Spear.Acl { delete : &quot;$all&quot; , metadata_read : &quot;$all&quot; , metadata_write : &quot;$all&quot; , read : &quot;$all&quot; , write : &quot;$all&quot; }","ref":"Spear.Acl.html#t:t/0","title":"Spear.Acl.t/0","type":"type"},{"doc":"A data structure representing the response to a batch-append request This structure is sent to the :send_ack_to option when using Spear.append_batch/5 .","ref":"Spear.BatchAppendResult.html","title":"Spear.BatchAppendResult","type":"module"},{"doc":"A response to a batch-append request When the batch-append succeeds, EventStoreDB returns the current revision and position info in the appended stream. These fields will be nil if the append does not succeed.","ref":"Spear.BatchAppendResult.html#t:t/0","title":"Spear.BatchAppendResult.t/0","type":"type"},{"doc":"A struct representing a member of a cluster of EventStoreDBs","ref":"Spear.ClusterMember.html","title":"Spear.ClusterMember","type":"module"},{"doc":"","ref":"Spear.ClusterMember.html#from_member_info/1","title":"Spear.ClusterMember.from_member_info/1","type":"function"},{"doc":"A possible state for an EventStoreDB cluster member","ref":"Spear.ClusterMember.html#t:state/0","title":"Spear.ClusterMember.state/0","type":"type"},{"doc":"A struct representing a member of a cluster of EventStoreDBs These are returned by Spear.cluster_info/2 . Examples iex&gt; Spear . cluster_info ( conn ) { :ok , [ % Spear.ClusterMember { address : &quot;127.0.0.1&quot; , alive? : true , instance_id : &quot;eba4c27f-e443-4b21-8756-00845bc5cda1&quot; , port : 2113 , state : :Leader , timestamp : ~U[2021-04-19 17:25:17.875824Z] } ] }","ref":"Spear.ClusterMember.html#t:t/0","title":"Spear.ClusterMember.t/0","type":"type"},{"doc":"Configuration for Spear.Connection s Options :name - the name of the GenServer. See GenServer.name/0 for more information. When not provided, the spawned process is not aliased to a name and is only addressable through its PID. :connection_string - the connection string to parse containing all connection information. Other options like :host or :port will be parsed from the connection string. If options parsed from the connection string are passed, they will be treated as overrides to the value found in the connection string. Consult the EventStoreDB documentation for formulating a valid connection string. :mint_opts - (default: [protocols: [:http2], mode: :active] ) a keyword list of options to pass to mint. The default values cannot be overridden. This can be useful for configuring TLS. See the security guide for more information. :host - (default: &quot;localhost&quot; ) the host address of the EventStoreDB :port - (default: 2113 ) the external gRPC port of the EventStoreDB :tls? - (default: false ) whether or not to use TLS to secure the connection to the EventStoreDB :username - (default: &quot;admin&quot; ) the user to connect as :password - (default: &quot;changeit&quot; ) the user's password :keep_alive_interval - (default: 10_000 ms - 10s) the period to send keep-alive pings to the EventStoreDB. Set -1 to disable keep-alive checks. Should be any integer value &gt;= 10_000 . This option can be used in conjunction with :keep_alive_timeout to properly disconnect if the EventStoreDB is not responding to network traffic. :keep_alive_timeout - (default: 10_000 ms - 10s) the time after sending a keep-alive ping when the ping will be considered unacknowledged. Used in conjunction with :keep_alive_interval . Set to -1 to disable keep-alive checks. Should be any integer value &gt;= 10_000 . :read_only? - (default: false ) controls whether the connection should be limited to read-only functionality. The list of read-only APIs can be queried with Spear.Connection.read_apis/0 See the Spear.Connection module docs for more information about keep-alive.","ref":"Spear.Connection.Configuration.html","title":"Spear.Connection.Configuration","type":"module"},{"doc":"Parses configuration from a keyword list This function is used internally by Spear.Connection when connecting.","ref":"Spear.Connection.Configuration.html#new/1","title":"Spear.Connection.Configuration.new/1","type":"function"},{"doc":"Configuration for a Spear.Connection .","ref":"Spear.Connection.Configuration.html#t:t/0","title":"Spear.Connection.Configuration.t/0","type":"type"},{"doc":"A simplified event struct This event struct is easier to work with than the protobuf definitions for AppendReq and ReadResp records","ref":"Spear.Event.html","title":"Spear.Event","type":"module"},{"doc":"Converts a read-response message to a Spear.Event This function is applied by Stream.map/2 onto streams returned by reading operations such as Spear.stream!/3 , Spear.read_stream/3 , etc. by default. This can be turned off by passing the raw?: true opt to a reading function. This function follows links. For example, if an read event belongs to a projected stream such as an event type stream, this function will give the event body of the source event, not the link. Forcing the return of the link body can be accomplished with the :link? option set to true (it is false by default). Options :link? - (default: false ) forces returning the body of the link event for events read from projected streams. Has no effect on events from non- projected streams. :json_decoder - (default: Jason.decode!/2 ) a 2-arity function to use for events with a &quot;content-type&quot; of &quot;application/json&quot; . All remaining options passed as opts other than :link? and :json_decoder are passed to the second argument of the :json_decoder 2-arity function. JSON decoding Event bodies are commonly written to the EventStoreDB in JSON format as the format is a human-readable and supported in nearly any language. Events carry a small piece of metadata in the ReadResp.ReadEvent.RecordedEvent 's :metadata map field which declares the content-type of the event body: &quot;content-type&quot; . This function will automatically attempt to decode any events which declare an &quot;application/json&quot; content-type as JSON using the :json_decoder 2-arity function option. Other content-types will not trigger any automatic behavior. Spear takes an optional dependency on the Jason library as it is currently the most popular JSON (en/de)coding library. If you add this project to the deps/0 in a mix.exs file and wish to take advantage of the automatic JSON decoding functionality, you may also need to include :jason . As an optional dependency, :jason is not included in your dependencies just by dependending on :spear . # mix.exs def deps do [ { :spear , &quot;&gt;= 0.0.0&quot; } , { :jason , &quot;&gt;= 0.0.0&quot; } , .. ] end Other JSON (en/de)coding libraries may be swapped in, such as with Poison iex&gt; Spear . stream! ( conn , &quot;es_supported_clients&quot; , raw? : true ) ...&gt; |&gt; Stream . map ( &amp; Spear.Event . from_read_response ( &amp;1 , json_decoder : &amp; Poison . decode! / 2 , keys : :atoms ) ) Examples Spear . stream! ( conn , &quot;es_supported_clients&quot; , raw? : true ) |&gt; Stream . map ( &amp; Spear.Event . from_read_response / 1 ) |&gt; Enum . to_list ( ) # =&gt; [%Spear.Event{}, %Spear.Event{}, ..]","ref":"Spear.Event.html#from_read_response/2","title":"Spear.Event.from_read_response/2","type":"function"},{"doc":"Returns the ID of the event, following the event's link if provided Examples iex&gt; Spear.Event . id ( % Spear.Event { link : nil , id : &quot;817cf20b-6791-4979-afdd-da4b03e02007&quot; , .. ) &quot;817cf20b-6791-4979-afdd-da4b03e02007&quot; iex&gt; Spear.Event . id ( ...&gt; % Spear.Event { ...&gt; link : % Spear.Event { id : &quot;976601b0-3775-442e-b98c-5f56af809402&quot; , .. } , ...&gt; id : &quot;817cf20b-6791-4979-afdd-da4b03e02007&quot; , ...&gt; .. ...&gt; } ...&gt; ) &quot;976601b0-3775-442e-b98c-5f56af809402&quot;","ref":"Spear.Event.html#id/1","title":"Spear.Event.id/1","type":"function"},{"doc":"Creates an event struct This function does not append the event to a stream on its own, but can provide events to Spear.append/4 which will append events to a stream. type is any string used to declare how the event is typed. This is very arbitrary and may coincide with struct names or may be hard-coded per event. Options :id - (default: Spear.Event.uuid_v4() ) the event's ID. See the section on event IDs below. :content_type - (default: &quot;application/json&quot; ) the encoding used to turn the event's body into binary data. If the content-type is &quot;application/json&quot; , the EventStoreDB and Spear (in Spear.Event.from_read_response/2 ) :custom_metadata - (default: &quot;&quot; ) an event field outside of the body meant as a bag for storing custom attributes about an event. Usage of this field is not obligatory: leaving it blank is perfectly normal. Event IDs EventStoreDB uses event IDs to provide an idempotency feature. Any event written to the EventStoreDB with an already existing ID will be not be duplicated. iex&gt; event = Spear.Event . new ( &quot;grpc-client&quot; , %{ &quot;languages&quot; =&gt; [ &quot;typescript&quot; , &quot;javascript&quot; ] , &quot;runtime&quot; =&gt; &quot;NodeJS&quot; } ) % Spear.Event { body : %{ &quot;languages&quot; =&gt; [ &quot;typescript&quot; , &quot;javascript&quot; ] , &quot;runtime&quot; =&gt; &quot;NodeJS&quot; } , id : &quot;1e654b2a-ff04-4af8-887f-052442edcd83&quot; , metadata : %{ content_type : &quot;application/json&quot; , custom_metadata : &quot;&quot; } , type : &quot;grpc-client&quot; } iex&gt; [ event ] |&gt; Spear . append ( conn , &quot;idempotency_test&quot; ) :ok iex&gt; [ event ] |&gt; Spear . append ( conn , &quot;idempotency_test&quot; ) :ok iex&gt; Spear . stream! ( conn , &quot;idempotency_test&quot; ) |&gt; Enum . to_list ( ) [ % Spear.Event { body : %{ &quot;languages&quot; =&gt; [ &quot;typescript&quot; , &quot;javascript&quot; ] , &quot;runtime&quot; =&gt; &quot;NodeJS&quot; } , id : &quot;1e654b2a-ff04-4af8-887f-052442edcd83&quot; , metadata : %{ commit_position : 18446744073709551615 , content_type : &quot;application/json&quot; , created : ~U[2021-04-07 21:53:40.395681Z] , custom_metadata : &quot;&quot; , prepare_position : 18446744073709551615 , stream_name : &quot;idempotency_test&quot; , stream_revision : 0 } , type : &quot;grpc-client&quot; } ] Examples File . stream! ( &quot;data.csv&quot; ) |&gt; MyCsvParser . parse_stream ( ) |&gt; Stream . map ( fn [ id , type , amount ] -&gt; Spear.Event . new ( &quot;ChargeDeclared&quot; , %{ id : id , type : type , amount : amount } ) end ) |&gt; Spear . append ( conn , &quot;ChargesFromCsvs&quot; , batch_size : 20 )","ref":"Spear.Event.html#new/3","title":"Spear.Event.new/3","type":"function"},{"doc":"Returns the revision of the event, following the event's link if provided Examples iex&gt; Spear.Event . revision ( % Spear.Event { link : nil , metadata : %{ stream_revision : 1 , .. } , .. } ) 1 iex&gt; Spear.Event . revision ( ...&gt; % Spear.Event { ...&gt; link : % Spear.Event { metadata : %{ stream_revision : 1 , .. } , .. } , ...&gt; metadata : %{ stream_revision : 0 , .. } , ...&gt; .. ...&gt; } ...&gt; ) 1","ref":"Spear.Event.html#revision/1","title":"Spear.Event.revision/1","type":"function"},{"doc":"Converts an event into a checkpoint This is useful when storing stream positions in Spear.subscribe/4 subscriptions to the :all stream.","ref":"Spear.Event.html#to_checkpoint/1","title":"Spear.Event.to_checkpoint/1","type":"function"},{"doc":"Converts a Spear.Event into an append-request record which proposes a new message Note that each event must be individually structured as an AppendReq record in order to be written to an EventStoreDB. The RPC definition for writing events specifies a stream input, though, so all AppendReq events passed to Spear.append/4 will be batched into a single write operation. This write operation appears to be transactional: any events in a single call to Spear.append/4 will only be appended if all events can be appended. rpc Append (stream AppendReq) returns (AppendResp); These messages are serialized to wire data before being sent to the EventStoreDB when using Spear.append/4 to write events via protobuf encoding. encoder_mapping is a mapping of content-types to 1-arity encode functions. The default is %{ &quot;application/json&quot; =&gt; &amp; Jason . encode! / 1 } The Spear.Event.t/0 's .metadata.content_type value will be searched in this map. If an encoder is found for that content-type, the event body will be encoded with the encoding function. If no encoder is found, the event body will be passed as-is. To set up an encoder for something like Erlang term format, an encoding map like the following could be used %{ &quot;application/vnd.erlang-term-format&quot; =&gt; &amp; :erlang . term_to_binary / 1 } In order to disable JSON encoding, pass an empty map %{} as the encoder_mapping Examples iex&gt; events [ % Spear.Event { } , % Spear.Event { } , .. ] iex&gt; events |&gt; Enum . map ( &amp; Spear.Event . to_proposed_message / 1 ) [ { :&quot;event_store.client.streams.AppendReq&quot; , .. } , .. ]","ref":"Spear.Event.html#to_proposed_message/3","title":"Spear.Event.to_proposed_message/3","type":"function"},{"doc":"Produces a random UUID v4 in human-readable format Examples iex&gt; Spear.Event . uuid_v4 &quot;98d3a5e2-ceb4-4a78-8084-97edf9452823&quot; iex&gt; Spear.Event . uuid_v4 &quot;2629ea4b-d165-45c9-8a2f-92b5e20b894e&quot;","ref":"Spear.Event.html#uuid_v4/0","title":"Spear.Event.uuid_v4/0","type":"function"},{"doc":"Produces a consistent UUID v4 in human-readable format given any input data structure This function can be used to generate a consistent UUID for a data structure of any shape. Under the hood it uses :erlang.phash2/1 to hash the data structure, which should be portable across many environments. This function can be taken advantage of to generate consistent event IDs for the sake of idempotency (see the Event ID section in new/3 for more information). Pass the :id option to new/3 to override the default random UUID generation. Note that it this implementation is naive and not easily portable across programming languages because of the reliance on :erlang.phash2/1 . A v5 UUID can be used instead to the same effect with more portability, however a v5 UUID generator is not included in this library. Examples iex&gt; Spear.Event . uuid_v4 %{ &quot;foo&quot; =&gt; &quot;bar&quot; } &quot;33323639-3934-4339-b332-363939343339&quot; iex&gt; Spear.Event . uuid_v4 %{ &quot;foo&quot; =&gt; &quot;bar&quot; } &quot;33323639-3934-4339-b332-363939343339&quot;","ref":"Spear.Event.html#uuid_v4/1","title":"Spear.Event.uuid_v4/1","type":"function"},{"doc":"A struct representing an EventStoreDB event Spear.Event.t/0 s may be created to write to the EventStoreDB with new/3 . Spear.Event.t/0 s will be lazily mapped into gRPC-compatible structs before being written to the EventStoreDB with to_proposed_message/2 . Spear.Event.t/0 s typically look different between events which are written to- and events which are read from the EventStoreDB. Read events contain more metadata which pertains to EventStoreDB specifics like the creation timestamp of the event. Links The :link field of a Spear.Event.t/0 can contain another Spear.Event.t/0 struct. Link events are pointers to other events and are used by the EventStoreDB to provide the projections feature without having to duplicate events across streams. Links do not usually contain any information useful to consumers, but clients must keep track of links in order to keep an accurate position in a projected stream, or in order to Spear.ack/3 / Spear.nack/4 the projected events in a persistent subscription. The :from option in functions like Spear.read_stream/3 , Spear.stream!/3 or Spear.subscribe/4 will use the link event's .metadata.stream_revision when reading projected streams. Spear.ack/3 and Spear.nack/4 take the link's :id field when passed a Spear.Event.t/0 . When not passing Spear.Event.t/0 s (for example, if curating the stream revisions or IDs in a database), the revision/1 and id/1 functions may be used to return the proper metadata for standard subscriptions and persistent subscriptions, respectively. Examples iex&gt; Spear . stream! ( conn , &quot;es_supported_clients&quot; ) |&gt; Enum . take ( 1 ) [ % Spear.Event { body : %{ &quot;languages&quot; =&gt; [ &quot;typescript&quot; , &quot;javascript&quot; ] , &quot;runtime&quot; =&gt; &quot;NodeJS&quot; } , id : &quot;1fc908c1-af32-4d06-a9bd-3bf86a833fdf&quot; , metadata : %{ commit_position : 18446744073709551615 , content_type : &quot;application/json&quot; , created : ~U[2021-04-01 21:11:38.196799Z] , custom_metadata : &quot;&quot; , prepare_position : 18446744073709551615 , stream_name : &quot;es_supported_clients&quot; , stream_revision : 0 } , type : &quot;grpc-client&quot; , link : nil } ] iex&gt; Spear.Event . new ( &quot;grpc-client&quot; , %{ &quot;languages&quot; =&gt; [ &quot;typescript&quot; , &quot;javascript&quot; ] , &quot;runtime&quot; =&gt; &quot;NodeJS&quot; } , % Spear.Event { body : %{ &quot;languages&quot; =&gt; [ &quot;typescript&quot; , &quot;javascript&quot; ] , &quot;runtime&quot; =&gt; &quot;NodeJS&quot; } , id : &quot;b952575a-1014-404d-ba20-f0904df7954e&quot; , metadata : %{ content_type : &quot;application/json&quot; , custom_metadata : &quot;&quot; } , type : &quot;grpc-client&quot; , link : nil }","ref":"Spear.Event.html#t:t/0","title":"Spear.Event.t/0","type":"type"},{"doc":"A structure representing how an append request's expectations were violated Expectations A client may exert expectations on write requests which will fail the request if violated. Any of these values may be passed to the :expect option of Spear.append/4 : :any - (default) any stream. Cannot be violated. :exists - the EventStoreDB stream must exist prior to the proposed events being written :empty - the EventStoreDB stream must not exist prior to the proposed events being written revision - any positive integer representing the current size of the stream. The head of the EventStoreDB stream must match this revision number in order for the append request to succeed. If an expectation is violated, the return signature will be {:error, %Spear.ExpectationViolation{}} , which gives information about the expectation and the current revision. See t/0 . Expectations may also be set in Spear.delete_stream/3 , although if expectations set on a deletion request are violated, EventStoreDB returns a gRPC error response instead of this struct.","ref":"Spear.ExpectationViolation.html","title":"Spear.ExpectationViolation","type":"module"},{"doc":"A structure representing how an append request's expectations were violated This struct is returned on calls to Spear.append/4 which set an expectation on the current stream revision with the :expect option. :current is not the number of events in the EventStoreDB stream but rather the current event revision. If three events are appended to an empty stream, the :current will be 2 . Note that deletions do not reset a stream's revision number. Examples # say EventStoreDB stream &quot;stream_that_should_be_empty&quot; has 6 events iex&gt; Spear . append ( events , conn , &quot;stream_that_should_be_empty&quot; , expect : :empty ) { :error , % Spear.ExpectationViolation { current : 5 , expected : :empty } } # say EventStoreDB stream &quot;stream_that_should_have_events&quot; has no events iex&gt; Spear . append ( events , conn , &quot;stream_that_should_have_events&quot; , expect : :exists ) { :error , % Spear.ExpectationViolation { current : :empty , expected : :exists } }","ref":"Spear.ExpectationViolation.html#t:t/0","title":"Spear.ExpectationViolation.t/0","type":"type"},{"doc":"A struct representing a checkpoint in server-side filtering","ref":"Spear.Filter.Checkpoint.html","title":"Spear.Filter.Checkpoint","type":"module"},{"doc":"A struct representing a checkpoint in a server-side filter operation When subscribing to the :all stream, one may provide a :filter option which the server will use to filter events before sending them over the network. Since the results of a server-side filtering subscription can be sparsely spread out in the entire :all stream, the EventStoreDB emits checkpoints as it reads through the events. A client can restore its position in a filter subscription by passing one of these structs to the :from option of Spear.subscribe/4 . See the Spear.Filter documentation for more information.","ref":"Spear.Filter.Checkpoint.html#t:t/0","title":"Spear.Filter.Checkpoint.t/0","type":"type"},{"doc":"A struct representing a persistent subscription and its settings","ref":"Spear.PersistentSubscription.html","title":"Spear.PersistentSubscription","type":"module"},{"doc":"","ref":"Spear.PersistentSubscription.html#map_update_stream_option/2","title":"Spear.PersistentSubscription.map_update_stream_option/2","type":"function"},{"doc":"The action the EventStoreDB should take for an event's nack :park - stops the EventStoreDB from re-sending the event and appends a reference to the event to the persistent subscription's parked events stream. These events can be retried later by clicking the &quot;Replay Parked Messages&quot; button in the EventStoreDB dashboard's persistent subscriptions section for each stream+group combination. The EventStoreDB parking system is conceptually similar to dead letter queues. :retry - retries the event up to :max_retry_count tries. This option is a reasonable default so that if a consumer hits a transient error condition such as a network timeout, it will retry the event before giving up and parking. Note that once a consumer has retried an event more than :max_retry_count times, the event is parked, even if the :retry action is given to Spear.nack/4 . :skip - skips the event without moving it to the parked events stream. Practically this is no different than simply Spear.ack/3 ing the event(s) and performing a no-op in the consumer. Skipping may be a good option for dealing with poison messages: malformed or otherwise completely unhandleable events. :stop - stops the EventStoreDB from re-sending the event. The event is not parked or retried. It is unclear how this differs from the :skip action. This function does not stop the persistent subscription: use Spear.cancel_subscription/3 to shut down the connection.","ref":"Spear.PersistentSubscription.html#t:nack_action/0","title":"Spear.PersistentSubscription.nack_action/0","type":"type"},{"doc":"A persistent subscription. These are generally returned from Spear.list_persistent_subscriptions/2 . Persistent subscriptions are considered unique by their stream name and group name pairings. A stream may have many different persistent subscriptions with different group names and settings and a group name may be used for multiple subscriptions to different streams. Examples iex&gt; Spear . create_persistent_subscription ( conn , &quot;my_stream&quot; , &quot;my_group&quot; , % Spear.PersistentSubscription.Settings { } ) :ok iex&gt; { :ok , subscriptions } = Spear . list_persistent_subscriptions ( conn ) iex&gt; subscriptions |&gt; Enum . to_list ( ) [ % Spear.PersistentSubscription { group_name : &quot;my_group&quot; , settings : % Spear.PersistentSubscription.Settings { checkpoint_after : 3000 , extra_statistics? : nil , history_buffer_size : 300 , live_buffer_size : 100 , max_checkpoint_count : 100 , max_retry_count : 10 , max_subscriber_count : 1 , message_timeout : 5000 , min_checkpoint_count : 1 , named_consumer_strategy : :RoundRobin , read_batch_size : 100 , resolve_links? : true , revision : 0 } , stream_name : &quot;my_stream&quot; } ]","ref":"Spear.PersistentSubscription.html#t:t/0","title":"Spear.PersistentSubscription.t/0","type":"type"},{"doc":"A struct representing possible settings for a persistent subscription","ref":"Spear.PersistentSubscription.Settings.html","title":"Spear.PersistentSubscription.Settings","type":"module"},{"doc":"Possible values for consumer strategies The consumer strategy controls how messages are distributed to multiple subscribers. The setting has no effect for single-subscriber persistent subscriptions.","ref":"Spear.PersistentSubscription.Settings.html#t:consumer_strategy/0","title":"Spear.PersistentSubscription.Settings.consumer_strategy/0","type":"type"},{"doc":"Settings for a persistent subscription See the EventStoreDB documentation for more information on each setting. The defaults for this struct are set up for a simple case of a single subscriber process. :message_timeout and :checkpoint_after may either be specified as {:ticks, ticks} or any integer where the ticks denote the EventStoreDB tick timing. Integers are read as durations in milliseconds.","ref":"Spear.PersistentSubscription.Settings.html#t:t/0","title":"Spear.PersistentSubscription.Settings.t/0","type":"type"},{"doc":"A data structure representing a position in the $all stream","ref":"Spear.Position.html","title":"Spear.Position","type":"module"},{"doc":"A struct representing the prepare and commit positions for an event in the $all stream","ref":"Spear.Position.html#t:t/0","title":"Spear.Position.t/0","type":"type"},{"doc":"A struct representing a scavenge and its progress","ref":"Spear.Scavenge.html","title":"Spear.Scavenge","type":"module"},{"doc":"The result of starting or stopping a scavenge This structure does not represent the current status of a scavenge. The scavenge stream ( Spear.scavenge_stream/1 ) may be read to determine the current status of a scavenge. Examples iex&gt; { :ok , scavenge } = Spear . start_scavenge ( conn ) { :ok , % Spear.Scavenge { id : &quot;d2897ba8-2f0c-4fc4-bb25-798ba75f3562&quot; , result : :Started } }","ref":"Spear.Scavenge.html#t:t/0","title":"Spear.Scavenge.t/0","type":"type"},{"doc":"A struct for describing the metadata about a stream","ref":"Spear.StreamMetadata.html","title":"Spear.StreamMetadata","type":"module"},{"doc":"Converts a stream metadata struct to a map in the format EventStoreDB expects","ref":"Spear.StreamMetadata.html#to_map/1","title":"Spear.StreamMetadata.to_map/1","type":"function"},{"doc":"Internal and custom metadata about a stream See the EventStoreDB stream metadata documentation for more details.","ref":"Spear.StreamMetadata.html#t:t/0","title":"Spear.StreamMetadata.t/0","type":"type"},{"doc":"A struct representing supported RPC in the currently connected EventStoreDB This structure is returned by Spear.get_supported_rpcs/2 .","ref":"Spear.SupportedRpc.html","title":"Spear.SupportedRpc","type":"module"},{"doc":"A struct representing a feature implemented by the currently connected EventStoreDB version See Spear.get_supported_rpcs/2 for more information.","ref":"Spear.SupportedRpc.html#t:t/0","title":"Spear.SupportedRpc.t/0","type":"type"},{"doc":"A struct representing an EventStoreDB user These are returned from Spear.user_details/3 .","ref":"Spear.User.html","title":"Spear.User","type":"module"},{"doc":"","ref":"Spear.User.html#from_details_resp/1","title":"Spear.User.from_details_resp/1","type":"function"},{"doc":"A struct representing an EventStoreDB user The :enabled? flag controls whether or not a user may execute requests, even with valid login information. This can be used to temporarily disable a user as an alternative to deleting the user altogether. Examples iex&gt; Spear . create_user ( conn , &quot;Aladdin&quot; , &quot;aladdin&quot; , &quot;open sesame&quot; , [ &quot;$ops&quot; ] ) :ok iex&gt; Spear . user_details ( conn , &quot;aladdin&quot; ) { :ok , % Spear.User { enabled? : true , full_name : &quot;Aladdin&quot; , groups : [ &quot;$ops&quot; ] , last_updated : ~U[2021-04-18 16:48:38.583313Z] , login_name : &quot;aladdin&quot; } }","ref":"Spear.User.html#t:t/0","title":"Spear.User.t/0","type":"type"},{"doc":"A record-like wrapper around google protobufs","ref":"Spear.Records.Google.html","title":"Spear.Records.Google","type":"module"},{"doc":"","ref":"Spear.Records.Google.html#duration/2","title":"Spear.Records.Google.duration/2","type":"function"},{"doc":"","ref":"Spear.Records.Google.html#empty/0","title":"Spear.Records.Google.empty/0","type":"macro"},{"doc":"","ref":"Spear.Records.Google.html#timestamp/1","title":"Spear.Records.Google.timestamp/1","type":"function"},{"doc":"A record macro interface for interacting with the EventStoreDB Gossip API","ref":"Spear.Records.Gossip.html","title":"Spear.Records.Gossip","type":"module"},{"doc":"","ref":"Spear.Records.Gossip.html#cluster_info/1","title":"Spear.Records.Gossip.cluster_info/1","type":"macro"},{"doc":"","ref":"Spear.Records.Gossip.html#cluster_info/2","title":"Spear.Records.Gossip.cluster_info/2","type":"macro"},{"doc":"","ref":"Spear.Records.Gossip.html#end_point/1","title":"Spear.Records.Gossip.end_point/1","type":"macro"},{"doc":"","ref":"Spear.Records.Gossip.html#end_point/2","title":"Spear.Records.Gossip.end_point/2","type":"macro"},{"doc":"","ref":"Spear.Records.Gossip.html#member_info/1","title":"Spear.Records.Gossip.member_info/1","type":"macro"},{"doc":"","ref":"Spear.Records.Gossip.html#member_info/2","title":"Spear.Records.Gossip.member_info/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Gossip.html#service/0","title":"Spear.Records.Gossip.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.Gossip.html#service_module/0","title":"Spear.Records.Gossip.service_module/0","type":"function"},{"doc":"A record macro interface for interacting with the EventStoreDB Streams API","ref":"Spear.Records.Monitoring.html","title":"Spear.Records.Monitoring","type":"module"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Monitoring.html#service/0","title":"Spear.Records.Monitoring.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.Monitoring.html#service_module/0","title":"Spear.Records.Monitoring.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Monitoring.html#stats_req/1","title":"Spear.Records.Monitoring.stats_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Monitoring.html#stats_req/2","title":"Spear.Records.Monitoring.stats_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Monitoring.html#stats_resp/1","title":"Spear.Records.Monitoring.stats_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Monitoring.html#stats_resp/2","title":"Spear.Records.Monitoring.stats_resp/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB Operations API","ref":"Spear.Records.Operations.html","title":"Spear.Records.Operations","type":"module"},{"doc":"","ref":"Spear.Records.Operations.html#scavenge_resp/1","title":"Spear.Records.Operations.scavenge_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#scavenge_resp/2","title":"Spear.Records.Operations.scavenge_resp/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Operations.html#service/0","title":"Spear.Records.Operations.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.Operations.html#service_module/0","title":"Spear.Records.Operations.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Operations.html#set_node_priority_req/1","title":"Spear.Records.Operations.set_node_priority_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#set_node_priority_req/2","title":"Spear.Records.Operations.set_node_priority_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#start_scavenge_req/1","title":"Spear.Records.Operations.start_scavenge_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#start_scavenge_req/2","title":"Spear.Records.Operations.start_scavenge_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#start_scavenge_req_options/1","title":"Spear.Records.Operations.start_scavenge_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#start_scavenge_req_options/2","title":"Spear.Records.Operations.start_scavenge_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#stop_scavenge_req/1","title":"Spear.Records.Operations.stop_scavenge_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#stop_scavenge_req/2","title":"Spear.Records.Operations.stop_scavenge_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#stop_scavenge_req_options/1","title":"Spear.Records.Operations.stop_scavenge_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Operations.html#stop_scavenge_req_options/2","title":"Spear.Records.Operations.stop_scavenge_req_options/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB Persistent Subscriptions API","ref":"Spear.Records.Persistent.html","title":"Spear.Records.Persistent","type":"module"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req/1","title":"Spear.Records.Persistent.create_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req/2","title":"Spear.Records.Persistent.create_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_all_options/1","title":"Spear.Records.Persistent.create_req_all_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_all_options/2","title":"Spear.Records.Persistent.create_req_all_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_all_options_filter_options/1","title":"Spear.Records.Persistent.create_req_all_options_filter_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_all_options_filter_options/2","title":"Spear.Records.Persistent.create_req_all_options_filter_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_all_options_filter_options_expression/1","title":"Spear.Records.Persistent.create_req_all_options_filter_options_expression/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_all_options_filter_options_expression/2","title":"Spear.Records.Persistent.create_req_all_options_filter_options_expression/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_options/1","title":"Spear.Records.Persistent.create_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_options/2","title":"Spear.Records.Persistent.create_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_position/1","title":"Spear.Records.Persistent.create_req_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_position/2","title":"Spear.Records.Persistent.create_req_position/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_settings/1","title":"Spear.Records.Persistent.create_req_settings/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_settings/2","title":"Spear.Records.Persistent.create_req_settings/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_stream_options/1","title":"Spear.Records.Persistent.create_req_stream_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_req_stream_options/2","title":"Spear.Records.Persistent.create_req_stream_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_resp/1","title":"Spear.Records.Persistent.create_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#create_resp/2","title":"Spear.Records.Persistent.create_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_req/1","title":"Spear.Records.Persistent.delete_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_req/2","title":"Spear.Records.Persistent.delete_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_req_options/1","title":"Spear.Records.Persistent.delete_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_req_options/2","title":"Spear.Records.Persistent.delete_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_resp/1","title":"Spear.Records.Persistent.delete_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#delete_resp/2","title":"Spear.Records.Persistent.delete_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#get_info_req/1","title":"Spear.Records.Persistent.get_info_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#get_info_req/2","title":"Spear.Records.Persistent.get_info_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#get_info_req_options/1","title":"Spear.Records.Persistent.get_info_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#get_info_req_options/2","title":"Spear.Records.Persistent.get_info_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#get_info_resp/1","title":"Spear.Records.Persistent.get_info_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#get_info_resp/2","title":"Spear.Records.Persistent.get_info_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#list_req/1","title":"Spear.Records.Persistent.list_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#list_req/2","title":"Spear.Records.Persistent.list_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#list_req_options/1","title":"Spear.Records.Persistent.list_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#list_req_options/2","title":"Spear.Records.Persistent.list_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#list_req_stream_option/1","title":"Spear.Records.Persistent.list_req_stream_option/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#list_req_stream_option/2","title":"Spear.Records.Persistent.list_req_stream_option/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#list_resp/1","title":"Spear.Records.Persistent.list_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#list_resp/2","title":"Spear.Records.Persistent.list_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req/1","title":"Spear.Records.Persistent.read_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req/2","title":"Spear.Records.Persistent.read_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_ack/1","title":"Spear.Records.Persistent.read_req_ack/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_ack/2","title":"Spear.Records.Persistent.read_req_ack/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_nack/1","title":"Spear.Records.Persistent.read_req_nack/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_nack/2","title":"Spear.Records.Persistent.read_req_nack/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_options/1","title":"Spear.Records.Persistent.read_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_options/2","title":"Spear.Records.Persistent.read_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_options_uuid_option/1","title":"Spear.Records.Persistent.read_req_options_uuid_option/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_req_options_uuid_option/2","title":"Spear.Records.Persistent.read_req_options_uuid_option/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp/1","title":"Spear.Records.Persistent.read_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp/2","title":"Spear.Records.Persistent.read_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_read_event/1","title":"Spear.Records.Persistent.read_resp_read_event/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_read_event/2","title":"Spear.Records.Persistent.read_resp_read_event/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_read_event_recorded_event/1","title":"Spear.Records.Persistent.read_resp_read_event_recorded_event/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_read_event_recorded_event/2","title":"Spear.Records.Persistent.read_resp_read_event_recorded_event/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_subscription_confirmation/1","title":"Spear.Records.Persistent.read_resp_subscription_confirmation/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#read_resp_subscription_confirmation/2","title":"Spear.Records.Persistent.read_resp_subscription_confirmation/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#replay_parked_req/1","title":"Spear.Records.Persistent.replay_parked_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#replay_parked_req/2","title":"Spear.Records.Persistent.replay_parked_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#replay_parked_req_options/1","title":"Spear.Records.Persistent.replay_parked_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#replay_parked_req_options/2","title":"Spear.Records.Persistent.replay_parked_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#replay_parked_resp/1","title":"Spear.Records.Persistent.replay_parked_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#replay_parked_resp/2","title":"Spear.Records.Persistent.replay_parked_resp/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Persistent.html#service/0","title":"Spear.Records.Persistent.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.Persistent.html#service_module/0","title":"Spear.Records.Persistent.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Persistent.html#subscription_info/1","title":"Spear.Records.Persistent.subscription_info/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#subscription_info/2","title":"Spear.Records.Persistent.subscription_info/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#subscription_info_connection_info/1","title":"Spear.Records.Persistent.subscription_info_connection_info/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#subscription_info_connection_info/2","title":"Spear.Records.Persistent.subscription_info_connection_info/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#subscription_info_measurement/1","title":"Spear.Records.Persistent.subscription_info_measurement/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#subscription_info_measurement/2","title":"Spear.Records.Persistent.subscription_info_measurement/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req/1","title":"Spear.Records.Persistent.update_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req/2","title":"Spear.Records.Persistent.update_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_all_options/1","title":"Spear.Records.Persistent.update_req_all_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_all_options/2","title":"Spear.Records.Persistent.update_req_all_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_options/1","title":"Spear.Records.Persistent.update_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_options/2","title":"Spear.Records.Persistent.update_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_position/1","title":"Spear.Records.Persistent.update_req_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_position/2","title":"Spear.Records.Persistent.update_req_position/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_settings/1","title":"Spear.Records.Persistent.update_req_settings/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_settings/2","title":"Spear.Records.Persistent.update_req_settings/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_stream_options/1","title":"Spear.Records.Persistent.update_req_stream_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_req_stream_options/2","title":"Spear.Records.Persistent.update_req_stream_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_resp/1","title":"Spear.Records.Persistent.update_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Persistent.html#update_resp/2","title":"Spear.Records.Persistent.update_resp/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB Projections API","ref":"Spear.Records.Projections.html","title":"Spear.Records.Projections","type":"module"},{"doc":"","ref":"Spear.Records.Projections.html#create_req/1","title":"Spear.Records.Projections.create_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req/2","title":"Spear.Records.Projections.create_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options/1","title":"Spear.Records.Projections.create_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options/2","title":"Spear.Records.Projections.create_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options_continuous/1","title":"Spear.Records.Projections.create_req_options_continuous/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options_continuous/2","title":"Spear.Records.Projections.create_req_options_continuous/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options_transient/1","title":"Spear.Records.Projections.create_req_options_transient/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_req_options_transient/2","title":"Spear.Records.Projections.create_req_options_transient/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_resp/1","title":"Spear.Records.Projections.create_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#create_resp/2","title":"Spear.Records.Projections.create_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_req/1","title":"Spear.Records.Projections.delete_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_req/2","title":"Spear.Records.Projections.delete_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_req_options/1","title":"Spear.Records.Projections.delete_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_req_options/2","title":"Spear.Records.Projections.delete_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_resp/1","title":"Spear.Records.Projections.delete_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#delete_resp/2","title":"Spear.Records.Projections.delete_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_req/1","title":"Spear.Records.Projections.disable_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_req/2","title":"Spear.Records.Projections.disable_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_req_options/1","title":"Spear.Records.Projections.disable_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_req_options/2","title":"Spear.Records.Projections.disable_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_resp/1","title":"Spear.Records.Projections.disable_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#disable_resp/2","title":"Spear.Records.Projections.disable_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_req/1","title":"Spear.Records.Projections.enable_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_req/2","title":"Spear.Records.Projections.enable_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_req_options/1","title":"Spear.Records.Projections.enable_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_req_options/2","title":"Spear.Records.Projections.enable_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_resp/1","title":"Spear.Records.Projections.enable_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#enable_resp/2","title":"Spear.Records.Projections.enable_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_req/1","title":"Spear.Records.Projections.reset_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_req/2","title":"Spear.Records.Projections.reset_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_req_options/1","title":"Spear.Records.Projections.reset_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_req_options/2","title":"Spear.Records.Projections.reset_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_resp/1","title":"Spear.Records.Projections.reset_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#reset_resp/2","title":"Spear.Records.Projections.reset_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_req/1","title":"Spear.Records.Projections.result_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_req/2","title":"Spear.Records.Projections.result_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_req_options/1","title":"Spear.Records.Projections.result_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_req_options/2","title":"Spear.Records.Projections.result_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_resp/1","title":"Spear.Records.Projections.result_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#result_resp/2","title":"Spear.Records.Projections.result_resp/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Projections.html#service/0","title":"Spear.Records.Projections.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.Projections.html#service_module/0","title":"Spear.Records.Projections.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Projections.html#state_req/1","title":"Spear.Records.Projections.state_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_req/2","title":"Spear.Records.Projections.state_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_req_options/1","title":"Spear.Records.Projections.state_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_req_options/2","title":"Spear.Records.Projections.state_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_resp/1","title":"Spear.Records.Projections.state_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#state_resp/2","title":"Spear.Records.Projections.state_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_req/1","title":"Spear.Records.Projections.statistics_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_req/2","title":"Spear.Records.Projections.statistics_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_req_options/1","title":"Spear.Records.Projections.statistics_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_req_options/2","title":"Spear.Records.Projections.statistics_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_resp/1","title":"Spear.Records.Projections.statistics_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_resp/2","title":"Spear.Records.Projections.statistics_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_resp_details/1","title":"Spear.Records.Projections.statistics_resp_details/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#statistics_resp_details/2","title":"Spear.Records.Projections.statistics_resp_details/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_req/1","title":"Spear.Records.Projections.update_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_req/2","title":"Spear.Records.Projections.update_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_req_options/1","title":"Spear.Records.Projections.update_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_req_options/2","title":"Spear.Records.Projections.update_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_resp/1","title":"Spear.Records.Projections.update_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Projections.html#update_resp/2","title":"Spear.Records.Projections.update_resp/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB ServerFeatures API introduced in server version v21.10.0","ref":"Spear.Records.ServerFeatures.html","title":"Spear.Records.ServerFeatures","type":"module"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.ServerFeatures.html#service/0","title":"Spear.Records.ServerFeatures.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.ServerFeatures.html#service_module/0","title":"Spear.Records.ServerFeatures.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.ServerFeatures.html#supported_method/1","title":"Spear.Records.ServerFeatures.supported_method/1","type":"macro"},{"doc":"","ref":"Spear.Records.ServerFeatures.html#supported_method/2","title":"Spear.Records.ServerFeatures.supported_method/2","type":"macro"},{"doc":"","ref":"Spear.Records.ServerFeatures.html#supported_methods/1","title":"Spear.Records.ServerFeatures.supported_methods/1","type":"macro"},{"doc":"","ref":"Spear.Records.ServerFeatures.html#supported_methods/2","title":"Spear.Records.ServerFeatures.supported_methods/2","type":"macro"},{"doc":"Shared record definitions for EventStoreDB messages","ref":"Spear.Records.Shared.html","title":"Spear.Records.Shared","type":"module"},{"doc":"","ref":"Spear.Records.Shared.html#access_denied/1","title":"Spear.Records.Shared.access_denied/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#access_denied/2","title":"Spear.Records.Shared.access_denied/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#all_stream_position/1","title":"Spear.Records.Shared.all_stream_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#all_stream_position/2","title":"Spear.Records.Shared.all_stream_position/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#bad_request/1","title":"Spear.Records.Shared.bad_request/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#bad_request/2","title":"Spear.Records.Shared.bad_request/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#empty/1","title":"Spear.Records.Shared.empty/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#empty/2","title":"Spear.Records.Shared.empty/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#invalid_transaction/1","title":"Spear.Records.Shared.invalid_transaction/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#invalid_transaction/2","title":"Spear.Records.Shared.invalid_transaction/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#maximum_append_size_exceeded/1","title":"Spear.Records.Shared.maximum_append_size_exceeded/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#maximum_append_size_exceeded/2","title":"Spear.Records.Shared.maximum_append_size_exceeded/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Shared.html#service/0","title":"Spear.Records.Shared.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.Shared.html#service_module/0","title":"Spear.Records.Shared.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Shared.html#stream_deleted/1","title":"Spear.Records.Shared.stream_deleted/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#stream_deleted/2","title":"Spear.Records.Shared.stream_deleted/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#stream_identifier/1","title":"Spear.Records.Shared.stream_identifier/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#stream_identifier/2","title":"Spear.Records.Shared.stream_identifier/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#timeout/1","title":"Spear.Records.Shared.timeout/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#timeout/2","title":"Spear.Records.Shared.timeout/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#unknown/1","title":"Spear.Records.Shared.unknown/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#unknown/2","title":"Spear.Records.Shared.unknown/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#uuid/1","title":"Spear.Records.Shared.uuid/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#uuid/2","title":"Spear.Records.Shared.uuid/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#uuid_structured/1","title":"Spear.Records.Shared.uuid_structured/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#uuid_structured/2","title":"Spear.Records.Shared.uuid_structured/2","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#wrong_expected_version/1","title":"Spear.Records.Shared.wrong_expected_version/1","type":"macro"},{"doc":"","ref":"Spear.Records.Shared.html#wrong_expected_version/2","title":"Spear.Records.Shared.wrong_expected_version/2","type":"macro"},{"doc":"A record macro interface for interacting with the google.rpc.Status type used in the protos","ref":"Spear.Records.Status.html","title":"Spear.Records.Status","type":"module"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Status.html#service/0","title":"Spear.Records.Status.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.Status.html#service_module/0","title":"Spear.Records.Status.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Status.html#status/1","title":"Spear.Records.Status.status/1","type":"macro"},{"doc":"","ref":"Spear.Records.Status.html#status/2","title":"Spear.Records.Status.status/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB Streams API","ref":"Spear.Records.Streams.html","title":"Spear.Records.Streams","type":"module"},{"doc":"","ref":"Spear.Records.Streams.html#append_req/1","title":"Spear.Records.Streams.append_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req/2","title":"Spear.Records.Streams.append_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req_options/1","title":"Spear.Records.Streams.append_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req_options/2","title":"Spear.Records.Streams.append_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req_proposed_message/1","title":"Spear.Records.Streams.append_req_proposed_message/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_req_proposed_message/2","title":"Spear.Records.Streams.append_req_proposed_message/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp/1","title":"Spear.Records.Streams.append_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp/2","title":"Spear.Records.Streams.append_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_position/1","title":"Spear.Records.Streams.append_resp_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_position/2","title":"Spear.Records.Streams.append_resp_position/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_success/1","title":"Spear.Records.Streams.append_resp_success/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_success/2","title":"Spear.Records.Streams.append_resp_success/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_wrong_expected_version/1","title":"Spear.Records.Streams.append_resp_wrong_expected_version/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#append_resp_wrong_expected_version/2","title":"Spear.Records.Streams.append_resp_wrong_expected_version/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_req/1","title":"Spear.Records.Streams.batch_append_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_req/2","title":"Spear.Records.Streams.batch_append_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_req_options/1","title":"Spear.Records.Streams.batch_append_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_req_options/2","title":"Spear.Records.Streams.batch_append_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_req_proposed_message/1","title":"Spear.Records.Streams.batch_append_req_proposed_message/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_req_proposed_message/2","title":"Spear.Records.Streams.batch_append_req_proposed_message/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_resp/1","title":"Spear.Records.Streams.batch_append_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_resp/2","title":"Spear.Records.Streams.batch_append_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_resp_success/1","title":"Spear.Records.Streams.batch_append_resp_success/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#batch_append_resp_success/2","title":"Spear.Records.Streams.batch_append_resp_success/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_req/1","title":"Spear.Records.Streams.delete_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_req/2","title":"Spear.Records.Streams.delete_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_req_options/1","title":"Spear.Records.Streams.delete_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_req_options/2","title":"Spear.Records.Streams.delete_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_resp/1","title":"Spear.Records.Streams.delete_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_resp/2","title":"Spear.Records.Streams.delete_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_resp_position/1","title":"Spear.Records.Streams.delete_resp_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#delete_resp_position/2","title":"Spear.Records.Streams.delete_resp_position/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req/1","title":"Spear.Records.Streams.read_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req/2","title":"Spear.Records.Streams.read_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options/1","title":"Spear.Records.Streams.read_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options/2","title":"Spear.Records.Streams.read_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_all_options/1","title":"Spear.Records.Streams.read_req_options_all_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_all_options/2","title":"Spear.Records.Streams.read_req_options_all_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_control_option/1","title":"Spear.Records.Streams.read_req_options_control_option/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_control_option/2","title":"Spear.Records.Streams.read_req_options_control_option/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_filter_options/1","title":"Spear.Records.Streams.read_req_options_filter_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_filter_options/2","title":"Spear.Records.Streams.read_req_options_filter_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_filter_options_expression/1","title":"Spear.Records.Streams.read_req_options_filter_options_expression/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_filter_options_expression/2","title":"Spear.Records.Streams.read_req_options_filter_options_expression/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_position/1","title":"Spear.Records.Streams.read_req_options_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_position/2","title":"Spear.Records.Streams.read_req_options_position/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_stream_options/1","title":"Spear.Records.Streams.read_req_options_stream_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_stream_options/2","title":"Spear.Records.Streams.read_req_options_stream_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_subscription_options/1","title":"Spear.Records.Streams.read_req_options_subscription_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_subscription_options/2","title":"Spear.Records.Streams.read_req_options_subscription_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_uuid_option/1","title":"Spear.Records.Streams.read_req_options_uuid_option/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_req_options_uuid_option/2","title":"Spear.Records.Streams.read_req_options_uuid_option/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp/1","title":"Spear.Records.Streams.read_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp/2","title":"Spear.Records.Streams.read_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_checkpoint/1","title":"Spear.Records.Streams.read_resp_checkpoint/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_checkpoint/2","title":"Spear.Records.Streams.read_resp_checkpoint/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_read_event/1","title":"Spear.Records.Streams.read_resp_read_event/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_read_event/2","title":"Spear.Records.Streams.read_resp_read_event/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_read_event_recorded_event/1","title":"Spear.Records.Streams.read_resp_read_event_recorded_event/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_read_event_recorded_event/2","title":"Spear.Records.Streams.read_resp_read_event_recorded_event/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_stream_not_found/1","title":"Spear.Records.Streams.read_resp_stream_not_found/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_stream_not_found/2","title":"Spear.Records.Streams.read_resp_stream_not_found/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_subscription_confirmation/1","title":"Spear.Records.Streams.read_resp_subscription_confirmation/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#read_resp_subscription_confirmation/2","title":"Spear.Records.Streams.read_resp_subscription_confirmation/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Streams.html#service/0","title":"Spear.Records.Streams.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.Streams.html#service_module/0","title":"Spear.Records.Streams.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_req/1","title":"Spear.Records.Streams.tombstone_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_req/2","title":"Spear.Records.Streams.tombstone_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_req_options/1","title":"Spear.Records.Streams.tombstone_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_req_options/2","title":"Spear.Records.Streams.tombstone_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_resp/1","title":"Spear.Records.Streams.tombstone_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_resp/2","title":"Spear.Records.Streams.tombstone_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_resp_position/1","title":"Spear.Records.Streams.tombstone_resp_position/1","type":"macro"},{"doc":"","ref":"Spear.Records.Streams.html#tombstone_resp_position/2","title":"Spear.Records.Streams.tombstone_resp_position/2","type":"macro"},{"doc":"A record macro interface for interacting with the EventStoreDB Users API","ref":"Spear.Records.Users.html","title":"Spear.Records.Users","type":"module"},{"doc":"","ref":"Spear.Records.Users.html#change_password_req/1","title":"Spear.Records.Users.change_password_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_req/2","title":"Spear.Records.Users.change_password_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_req_options/1","title":"Spear.Records.Users.change_password_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_req_options/2","title":"Spear.Records.Users.change_password_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_resp/1","title":"Spear.Records.Users.change_password_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#change_password_resp/2","title":"Spear.Records.Users.change_password_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_req/1","title":"Spear.Records.Users.create_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_req/2","title":"Spear.Records.Users.create_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_req_options/1","title":"Spear.Records.Users.create_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_req_options/2","title":"Spear.Records.Users.create_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_resp/1","title":"Spear.Records.Users.create_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#create_resp/2","title":"Spear.Records.Users.create_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_req/1","title":"Spear.Records.Users.delete_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_req/2","title":"Spear.Records.Users.delete_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_req_options/1","title":"Spear.Records.Users.delete_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_req_options/2","title":"Spear.Records.Users.delete_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_resp/1","title":"Spear.Records.Users.delete_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#delete_resp/2","title":"Spear.Records.Users.delete_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_req/1","title":"Spear.Records.Users.details_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_req/2","title":"Spear.Records.Users.details_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_req_options/1","title":"Spear.Records.Users.details_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_req_options/2","title":"Spear.Records.Users.details_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp/1","title":"Spear.Records.Users.details_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp/2","title":"Spear.Records.Users.details_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp_user_details/1","title":"Spear.Records.Users.details_resp_user_details/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp_user_details/2","title":"Spear.Records.Users.details_resp_user_details/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp_user_details_date_time/1","title":"Spear.Records.Users.details_resp_user_details_date_time/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#details_resp_user_details_date_time/2","title":"Spear.Records.Users.details_resp_user_details_date_time/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_req/1","title":"Spear.Records.Users.disable_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_req/2","title":"Spear.Records.Users.disable_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_req_options/1","title":"Spear.Records.Users.disable_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_req_options/2","title":"Spear.Records.Users.disable_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_resp/1","title":"Spear.Records.Users.disable_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#disable_resp/2","title":"Spear.Records.Users.disable_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_req/1","title":"Spear.Records.Users.enable_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_req/2","title":"Spear.Records.Users.enable_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_req_options/1","title":"Spear.Records.Users.enable_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_req_options/2","title":"Spear.Records.Users.enable_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_resp/1","title":"Spear.Records.Users.enable_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#enable_resp/2","title":"Spear.Records.Users.enable_resp/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_req/1","title":"Spear.Records.Users.reset_password_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_req/2","title":"Spear.Records.Users.reset_password_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_req_options/1","title":"Spear.Records.Users.reset_password_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_req_options/2","title":"Spear.Records.Users.reset_password_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_resp/1","title":"Spear.Records.Users.reset_password_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#reset_password_resp/2","title":"Spear.Records.Users.reset_password_resp/2","type":"macro"},{"doc":"Returns the gRPC service name for the API","ref":"Spear.Records.Users.html#service/0","title":"Spear.Records.Users.service/0","type":"function"},{"doc":"Returns the :gpb -generated service module","ref":"Spear.Records.Users.html#service_module/0","title":"Spear.Records.Users.service_module/0","type":"function"},{"doc":"","ref":"Spear.Records.Users.html#update_req/1","title":"Spear.Records.Users.update_req/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_req/2","title":"Spear.Records.Users.update_req/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_req_options/1","title":"Spear.Records.Users.update_req_options/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_req_options/2","title":"Spear.Records.Users.update_req_options/2","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_resp/1","title":"Spear.Records.Users.update_resp/1","type":"macro"},{"doc":"","ref":"Spear.Records.Users.html#update_resp/2","title":"Spear.Records.Users.update_resp/2","type":"macro"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning . Note : certain Spear versions add support for new EventStoreDB features gated behind new EventStoreDB versions. You should not downgrade your Spear version in order to avoid these features: Spear aims to keep a stable interface usable across all EventStoreDB versions v20+.","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Added Added support for Persistent Subscription RPCs introduced in server version 22.6.0: Spear.get_persistent_subscription_info/4 Spear.replay_parked_messages/4 Spear.restart_persistent_subscription_subsystem/2","ref":"changelog.html#1-2-0-2022-11-02","title":"Changelog - 1.2.0 - 2022-11-02","type":"extras"},{"doc":"Added A duration may now be specified for the :deadline option to Spear.append_batch/5 Passing a duration (instead of a timestamp) requires EventStoreDB version 21.10.5 or higher","ref":"changelog.html#1-1-0-2022-07-08","title":"Changelog - 1.1.0 - 2022-07-08","type":"extras"},{"doc":"Fixed 0 may now be passed in the :expect option when appending or batch appending","ref":"changelog.html#1-0-2-2022-06-02","title":"Changelog - 1.0.2 - 2022-06-02","type":"extras"},{"doc":"Fixed Fixed Spear.stream!/3 when providing a :from event number that does not exist Spear.stream!/3 gives the empty list in this case","ref":"changelog.html#1-0-1-2022-05-26","title":"Changelog - 1.0.1 - 2022-05-26","type":"extras"},{"doc":"This release represent stability in the API. There are no functional changes between this release and v0.11.0.","ref":"changelog.html#1-0-0-2022-05-11","title":"Changelog - 1.0.0 - 2022-05-11","type":"extras"},{"doc":"Added Added the :filter option to Spear.read_stream/3 and Spear.stream!/3 This allows one to perform a non-subscription read of the $all stream and use a server-side filter Added Spear.get_supported_rpcs/2 and Spear.Client.get_supported_rpcs/1 for getting the available RPC methods implemented in the connected EventStoreDB server Added Spear.get_server_version/2 and c:Spear.Client.get_server_version/2 for getting the version string of the connected EventStoreDB Server These features require the new EventStoreDB version v21.10.0 released on 2021-11-03. Changed According to the v21.10.0 server release notes 's breaking changes section, deleting a stream that does not currently exist will now throw an error","ref":"changelog.html#0-11-0-2021-11-04","title":"Changelog - 0.11.0 - 2021-11-04","type":"extras"},{"doc":"Added Implemented the creation, updating, reading, and deletion of persistent subscriptions to the :all stream this feature requires EventStoreDB v21.6.0 or later Implemented Spear.append_batch/5 for high-throughput asynchronous appends this feature requires EventStoreDB v21.6.0 or later Spear.append_batch_stream/2 has also been added for convenience Added Spear.subscribe_to_stats/3 and Spear.Client.subscribe_to_stats/2 this opens a subscription for EventStoreDB monitoring this feature requires EventStoreDB v21.6.0 or later Added a dependency on the :event_store_db_gpb_protobfs package this package is just a convenience for developing spear: we can build gpb definitions for the EventStoreDB protobufs on-the-fly via the rebar3 gpb plugin, so we never need to commit the erl/hrl files for the generated gpb modules. this also allows other (non-Elixir even) libraries to take advantage of versioned, pre-generated gpb definitions for the EventStoreDB grpc interface Changed Non-event read responses are now discarded when reading from a stream this will allow the compatibility of spear v0.10.0 with the next release of EventStoreDB this should not change behavior with any existing EventStoreDB versions Fixed Fixed the Spear.set_global_acl/4 function to correctly append ACL data as an event to the $streams metadata stream, instead of to the $streams stream directly.","ref":"changelog.html#0-10-0-2021-08-30","title":"Changelog - 0.10.0 - 2021-08-30","type":"extras"},{"doc":"Added Added Spear.park_stream/2 to the utilities API Fixed Removed compilation of mint version in user-agent function This could cause a compilation error when using spear as a transitive dependency","ref":"changelog.html#0-9-1-2021-06-01","title":"Changelog - 0.9.1 - 2021-06-01","type":"extras"},{"doc":"Added Added a :link field to the Spear.Event.t/0 struct this is used to provide accurate stream revisions and IDs in projected streams as with Spear.subscribe/4 or in Spear.ack/3 or Spear.nack/4 Added Spear.Event.id/1 and Spear.Event.revision/1 which take a Spear.Event.t/0 and give the ID and revision, respectively these new functions respect the new :link field and return link information instead of event information if the link is present Removed Removed link metadata from the Spear.Event.metadata map's possible :link field. use the new top-level :link field as Spear.Event.link.metadata Note that this may be a breaking change for any consumers depending on the optional :link field in the metadata packet. Consumers should update by instead matching on a Spear.Event.t/0 struct in the :link field of any event, or by using the new Spear.Event.id/1 or Spear.Event.revision/1 functions.","ref":"changelog.html#0-9-0-2021-04-29","title":"Changelog - 0.9.0 - 2021-04-29","type":"extras"},{"doc":"Added Added the link's stream to the Spear.Event.metadata.link field Fixed Fixed some stray references to structs which should be typed as records Fixed Spear.Event.to_checkpoint/1 to carry over the :subscription key from a Spear.Event.t/0 's metadata Fixed a bug in Spear.Connection.Configuration which would incorrectly choose the :http scheme when the :tls? option was set to true","ref":"changelog.html#0-8-1-2021-04-27","title":"Changelog - 0.8.1 - 2021-04-27","type":"extras"},{"doc":"Added Added the :read_only? configuration flag for Spear.Connection.Configuration this allows one to limit what the Spear.Connection will perform to read-only operations such as reading streams Added link metadata to the Spear.Event.metadata packet in a new :link field Fixed Fixed the :from option in read requests ( Spear.read_stream/3 , Spear.stream!/3 and Spear.subscribe/4 ) to respect the new link information in metadata","ref":"changelog.html#0-8-0-2021-04-26","title":"Changelog - 0.8.0 - 2021-04-26","type":"extras"},{"doc":"Added Added the subscription reference returned by Spear.subscribe/4 and Spear.connect_to_persistent_subscription/5 to the metadata map of Spear.Event.t/0 in the path Spear.Event.metadata.subscription Spear.Filter.Checkpoint.t/0 in a new field :subscription the :eos tuples in the new shape of {:eos, reference(), :closed | :dropped} Note that this is a breaking change for any consumers matching explicitly on :eos tuples. Consumers relying on the prior data shape should update like so - def handle_info({:eos, reason}, state) do + def handle_info({:eos, _subscription, reason}, state) do","ref":"changelog.html#0-7-0-2021-04-24","title":"Changelog - 0.7.0 - 2021-04-24","type":"extras"},{"doc":"Fixed Spear.stream!/3 now reads :from revisions as inclusive e.g. passing some event in the stream to :from will ensure that the first element in the enumerable is ^event the same principal applies when passing event revisions see #26 if this behavior is undesirable, a Spear user may Stream.drop/2 the initial element in the enumerable Spear.connect_to_persistent_subscription/5 now returns an error tuple when attempting to connect to a persistent subscription stream and group that has not yet been created. the reason is a Spear.Grpc.Response struct with a status of :not_found Added Subscriptions may now emit {:eos, :dropped} in cases where the EventStoreDB explicitly terminates the subscription this can happen if a persistent subscription is deleted while it has subscribers actively connected each subscriber will receive {:eos, :dropped} in its mailbox","ref":"changelog.html#0-6-1-2021-04-23","title":"Changelog - 0.6.1 - 2021-04-23","type":"extras"},{"doc":"Added Added the CRUD portions of persistent subscriptions API Spear.create_persistent_subscription/5 Spear.update_persistent_subscription/5 Spear.delete_persistent_subscription/4 Spear.list_persistent_subscriptions/2 associated callbacks in Spear.Client Added subscription functionality for persistent subscriptions Spear.connect_to_persistent_subscription/5 Spear.ack/3 Spear.nack/4 associated callbacks in Spear.Client Changed Moved Spear.cancel_subscription/3 under the utils API instead of streams This function may also be used to cancel persistent subscriptions","ref":"changelog.html#0-6-0-2021-04-21","title":"Changelog - 0.6.0 - 2021-04-21","type":"extras"},{"doc":"Added Added the gossip API this API is very small: just one function Spear.cluster_info/2 also added Spear.Client.cluster_info/1 under the hood, this also added the ability to decode structured UUIDs received from the EventStoreDB, as are received in the Spear.ClusterMember.instance_id field. See Spear.Uuid for the interesting implementation. added the record interface Spear.Records.Gossip Fixed Properly grouped free-floating modules under the proper structures and types or record interface groupings in the documentation","ref":"changelog.html#0-5-0-2021-04-19","title":"Changelog - 0.5.0 - 2021-04-19","type":"extras"},{"doc":"Fixed Updated security guide to use new configuration style Added Added the operations API Spear.merge_indexes/2 Spear.resign_node/2 Spear.restart_persistent_subscriptions/2 Spear.set_node_priority/3 Spear.shutdown/2 Spear.start_scavenge/2 Spear.stop_scavenge/3 and associated wrappers in Spear.Client","ref":"changelog.html#0-4-0-2021-04-19","title":"Changelog - 0.4.0 - 2021-04-19","type":"extras"},{"doc":"Added Added record interface modules for all remaining APIs Added functions for interacting with the Users API Spear.change_user_password/5 Spear.create_user/6 Spear.delete_user/3 Spear.disable_user/3 Spear.enable_user/3 Spear.reset_user_password/4 Spear.update_user/6 Spear.user_details/3 associated functions in Spear.Client","ref":"changelog.html#0-3-0-2021-04-18","title":"Changelog - 0.3.0 - 2021-04-18","type":"extras"},{"doc":"Added Wrapped new ACL-related functions in Spear.Client Spear.Client.get_stream_metadata/2 Spear.Client.set_stream_metadata/2 Spear.Client.set_global_acl/3","ref":"changelog.html#0-2-1-2021-04-17","title":"Changelog - 0.2.1 - 2021-04-17","type":"extras"},{"doc":"Changed Refactored connection configuration to go through validation :opts option has been renamed to :mint_opts credentials are passed through the :connection_string option or as :username and :password options Added Implemented and documented keep-alive This can be configured through the keepAliveInterval and keepAliveTimeout query params in :connection_string or by the new :keep_alive_interval and :keep_alive_timeout configuration options","ref":"changelog.html#0-2-0-2021-04-17","title":"Changelog - 0.2.0 - 2021-04-17","type":"extras"},{"doc":"Added {:eos, :closed} is now emitted when a subscription is broken due to the connection between closed between Spear.Connection and EventStoreDB Spear.Connection now monitors subscription processes and cancels EventStoreDB subscriptions upon subscriber process exit","ref":"changelog.html#0-1-4-2021-04-16","title":"Changelog - 0.1.4 - 2021-04-16","type":"extras"},{"doc":"Added Added documentation and functionality for using TLS certificates see Spear.Connection and the security guide Added documentation and functionality for setting the global stream ACL see Spear.set_global_acl/4 and the Spear.Acl module Added functionality for getting and setting stream-level metadata. Spear.meta_stream/1 Spear.get_stream_metadata/3 Spear.set_stream_metadata/3 Spear.StreamMetadata","ref":"changelog.html#0-1-3-2021-04-15","title":"Changelog - 0.1.3 - 2021-04-15","type":"extras"},{"doc":"Added Added dependency on connection Added ping functionality for Spear.Connection s Spear.ping/1 and Spear.ping/2 Spear.Client.ping/0 and Spear.Client.ping/1 Added the ability to disconnect a connection by GenServer.call/3 ing it with :close as the message Added the ability to explicitly reconnect a connection by GenServer.cast/2 ing it a message of :connect Changed Changed the internals of Spear.Connection to take advantage of the new Connection dependency A failure to connect on GenServer init for a connection will no longer take down the supervision tree Failures to connect will result in back-off retries in 500ms segments The life-cycle of the HTTP2 connection spawned by a Spear.Connection is now divorced from the life-cycle of the Spear.Connection process","ref":"changelog.html#0-1-2-2021-04-14","title":"Changelog - 0.1.2 - 2021-04-14","type":"extras"},{"doc":"Removed Removed dependency on elixir-protobuf/protobuf see #4 also removed all generated files from protobuf Added Added dependency on :gpb and associated generated erlang files Added Spear.Records.* interface for interacting with gpb-generated records","ref":"changelog.html#0-1-1-2021-04-14","title":"Changelog - 0.1.1 - 2021-04-14","type":"extras"},{"doc":"Added Initial implementation of a client for the streams API all notable functions are labeled with the since: &quot;0.1.0&quot; doc attribute","ref":"changelog.html#0-1-0-2021-04-12","title":"Changelog - 0.1.0 - 2021-04-12","type":"extras"},{"doc":"This guide covers specifics about the Spear.append/4 and Spear.append_batch/5 functions and general information about the event-writing functionality.","ref":"writing_events.html","title":"Writing Events","type":"extras"},{"doc":"event_stream is an Enumerable.t/0 which will be lazily written to the EventStoreDB as elements of the stream are computed and serialized on to the wire. This means a few things: First, you can efficiently emit events from a stream over a large source such as a CSV file with many lines: File . stream! ( &quot;large.csv&quot; , read_ahead : 100_000 ) |&gt; MyCsvParser . parse_stream ( ) |&gt; Stream . map ( &amp; MyCsvParser . turn_csv_line_into_spear_event / 1 ) |&gt; Spear . append ( conn , &quot;ChargesFromCsvs&quot; , timeout : :infinity ) # =&gt; :ok The stream is only fully run after the last bytes have been written to the gRPC network request: the stream is never computed entirely in memory. Second, you may (but are not encouraged to) write events via an infinite stream. A trivial counter mechanism could be implemented like so iex&gt; Stream . iterate ( 0 , &amp; ( &amp;1 + 1 ) ) ...&gt; |&gt; Stream . map ( fn n -&gt; Spear.Event . new ( &quot;incremented&quot; , n ) end ) ...&gt; |&gt; Spear . append ( conn , &quot;InfiniteCounter&quot; , timeout : :infinity , expect : :empty ) { :error , % Spear.Grpc.Response { data : &quot;&quot; , message : &quot;Maximum Append Size of 1048576 Exceeded.&quot; , status : :invalid_argument , status_code : 3 } } Note that while EventStoreDB streams can in theory store infinitely long streams, they are not practically able to do so. EventStoreDB limits the size of a single write to 1_048_576 cumulative bytes. This budget can be spent on one very large event or, as shown above, many tiny events in a single call to Spear.append/4 . Attempting to write more than the budget will fail the request with the above signature and no events in the request will be written to the EventStoreDB. This value is configurable in the EventStoreDB server configuration.","ref":"writing_events.html#enumeration-characteristics","title":"Writing Events - Enumeration Characteristics","type":"extras"},{"doc":"While Spear.append/4 blocks the caller for the duration of the request, it does not fully block the connection. The connection will write chunks of data over the wire as allowed by HTTP2 window sizes. HTTP2 includes a back-pressure mechanism for clients sending large amounts of data to the server faster than the server can handle. Servers negotiate a maximum number of bytes which the client is allowed to send called a window. When the window has been exhausted by streaming data to the server, the client must wait until the server replenishes the window. During the downtime between exhausting a window and waiting for the server to replenish, Spear suspends the exhausted request stream and handles incoming messages from the server as normal. Since HTTP2 window sizes are relatively small (usually somewhere around the range of 10 and 100 KB), Spear takes conceptual breaks somewhat often during large requests. This allows Spear to efficiently multiplex large writes with large reads and subscriptions.","ref":"writing_events.html#blocking","title":"Writing Events - Blocking","type":"extras"},{"doc":"EventStoreDB v21.6.0+'s BatchAppend feature is designed to improve performance of appending large numbers of events. The protobuf and gRPC service definitions give BatchAppend an advantage over the standard Append RPC both in terms of encoded message size (and therefore bytes over the network) and number of HTTP/2 requests. Spear.append/4 is a simpler interface for appends and is a reasonable default. Spear.append_batch/5 is more cumbersome to use but is also more powerful. In general, Spear.append_batch/5 should be preferred when writing large numbers of events and when append throughput is critical.","ref":"writing_events.html#increasing-append-throughput-with-spear-append_batch-5","title":"Writing Events - Increasing append throughput with Spear.append_batch/5","type":"extras"},{"doc":"Say we have an Enumerable.t/0 of event batches where each element is a tuple of the stream name to append to and a batch of events to append: {stream_name, [%Spear.Event{}, ...]} . We can use Task.async_stream/3 to parallelize appends like so: alias Spear.BatchAppendResult , as : Result [ { stream_name , event_batch } ] = Enum . take ( event_batch_stream , 1 ) { :ok , batch_id , request_id } = Spear . append_batch ( event_batch , conn , :new , stream_name ) receive ( do : ( % Result { batch_id : ^ batch_id , request_id : ^ request_id , result : :ok } -&gt; :ok ) ) We start by opening up a new Spear.append_batch/5 request using the :new atom as the request_id and the first element of the stream as input. event_batch_stream |&gt; Stream . drop ( 1 ) |&gt; Task . async_stream ( fn { stream_name , event_batch } -&gt; { :ok , batch_id } = Spear . append_batch ( event_batch , conn , request_id , stream_name ) receive do % Result { batch_id : ^ batch_id , request_id : ^ request_id , result : :ok } -&gt; :ok end end ) |&gt; Stream . run ( ) Now we drop the first element of our stream (which we appended to open the request) and pass the rest of the stream through Task.async_stream/2 . Task.async_stream/2 will apply the anonymous function to each element of the stream, so we append a batch for each {stream_name, event_batch} element and await the result. Task.async_stream/2 will spawn processes for each element, keeping at most System.schedulers_online/0 processes running at a time. Finally we'll close the request using Spear.cancel_subscription/2 :ok = Spear . cancel_subscription ( conn , request_id )","ref":"writing_events.html#example-use-streams-and-tasks-with-spear-append_batch-5","title":"Writing Events - Example: use Streams and Tasks with Spear.append_batch/5","type":"extras"},{"doc":"Spear uses Elixir Stream s consistency across its API but there are many conceptual meanings of &quot;stream&quot; in the systems which Spear composes. Consider this call: iex&gt; Spear . stream! ( conn , &quot;MyStream&quot; , chunk_size : 20 ) |&gt; Enum . to_list ( ) [ % Spear.Event { } , % Spear.Event { } , .. ] This call reads an EventStoreDB stream over an HTTP2 stream which is typed as a gRPC stream response and is collected into an Elixir Stream There are four significant concepts for streams in Spear: HTTP2 streams of data gRPC stream requests, responses, and bidirectional communication EventStoreDB streams of events Elixir Stream s We'll cover each topic separately to avoid confusion. HTTP2 streams HTTP2 streams are channels for data and may be multiplexed: multiple requests may stream data in either direction (client to server or server to client) at once. HTTP2 streams (and some GenServer tricks) allow Spear to multiplex requests and subscriptions in a single HTTP2 connection without blocking. Besides concurrency and blocking concerns, HTTP2 streams are mostly an implementation detail in Spear. gRPC streams gRPC allows &quot;unary&quot; request-responses similar to a REST request-response over HTTP. This resembles synchronous function (or GenServer) calls. The true power of gRPC, though, comes from its ability to &quot;stream&quot; requests, responses, or requests and responses simultaneously. Consider this RPC definition from the EventStoreDB gRPC protobufs: rpc Read (ReadReq) returns (stream ReadResp); In the Spear.stream!/3 function, this &quot;stream&quot; response lends itself to an Elixir Stream . Conceptually the ReadResp messages are returned as an ordered list of events in an EventStoreDB stream. These response messages are returned as quickly as possible and resemble a unary request very closely. This same RPC is invoked to implement Spear.subscribe/4 , though, which does not return an Elixir Enumerable.t/0 . Instead this function asynchronously signs-up the given process for receiving messages per event. gRPC streams may emulate synchronous calls returning lists as with Spear.stream!/3 but are also commonly used to implement asynchronous subscription workflows as with Spear.subscribe/4 . gRPC streams may even be fully asynchronous is both directions as with EventStoreDB Persistent Subscriptions. This communication is known as bidirectional or &quot;bidi-stream&quot; and is covered more fully in the Spear.PersistentSubscription moduledoc. gRPC streams are also an implementation-level detail in Spear and will not be mentioned otherwise in this documentation unless specifically called a &quot;gRPC stream&quot;. EventStoreDB streams EventStoreDB streams are append-only collections of events ordered by the timestamp of each event's commit (or commit preparation). Streams can be read forwards or backwards and from any revision (a fancy way of saying &quot;position in a stream&quot;). EventStoreDB streams will be referred to in this documentation as EventStoreDB streams, or simply &quot;streams&quot; where contextually appropriate. Elixir Streams Elixir Stream s are conceptually different than both gRPC/HTTP2 streams and EventStoreDB streams. Elixir Stream s differ as well from lazy enumerables in other languages like Haskell due to the lack of a &quot;thunk&quot; built-in. Stream s are simply formulas for producing enumerable collections such as List s. Since streams are a formula and not an actual list (or otherwise collectable), they can exploit some lovely properties: computations can be done lazily on demand this can reduce memory consumption streams can be composed streams can be infinite A common example is reading a large file such as a big CSV. Without streams, the entire file must be read into memory and each transformation of each line or chunk must be computed in entirety before moving on to the next operation (e.g. with Enum.map/2 or Enum.reduce/3 ). With a file stream, one may read a large file line-by-line, perform many Stream.map/2 s (or similar) and eventually perform some side-effect by forcing the stream with Stream.run/1 or an Enum function. Only once the first line or chunk has been read from the file and run through the pipeline of composed stream functions will the next one be read and run through. To differentiate, we will most commonly refer to Elixir Stream s in the Spear documentation by their canonical data-type: Enumerable.t/0 .","ref":"streams.html","title":"Streams","type":"extras"},{"doc":"Some functions in Spear have :resolve_links? options. Projected streams such as streams beginning with &quot;$&quot; or custom-made projected streams do not copy event bodies literally from linked events. For example, the &quot;$all&quot; projected stream does not contain a copy of every event in the eventstore. Rather projected streams are comprised of link events which are very slim references to the source events. This is conceptually similar to pointers in a language like C. When we read a projected stream (in this example an event-type stream) with :resolve_links? set to false, we see iex&gt; import Spear.Records.Streams iex&gt; Spear . stream! ( conn , &quot;$et-grpc-client&quot; , chunk_size : 1 , resolve_links? : false , raw? : true ) |&gt; Enum . take ( 1 ) [ read_resp ( content : { :event , read_resp_read_event ( event : read_resp_read_event_recorded_event ( data : &quot;0@es_supported_clients&quot; ) , link : :undefined ) ) ) ] (Note that the read-response bodies we see in this section are simplified to only show the parts interesting to link resolution.) The link field on the read event is nil and the event field has a strange data body of 0@es_supported_clients . With link resolution turned off, we are telling the EventStoreDB that we'd like to read the stream literally: to receive just the links themselves. When we turn link resolution on, we see a different picture iex&gt; import Spear.Records.Streams iex&gt; Spear . stream! ( conn , &quot;$et-grpc-client&quot; , chunk_size : 1 , resolve_links? : true , raw? : true ) |&gt; Enum . take ( 1 ) [ read_resp ( content : { :event , read_resp_read_event ( event : read_resp_read_event_recorded_event ( data : &quot;{ \\&quot; languages \\&quot; :[ \\&quot; typescript \\&quot; , \\&quot; javascript \\&quot; ], \\&quot; runtime \\&quot; : \\&quot; NodeJS \\&quot; }&quot; , ) , link : read_resp_read_event_recorded_event ( data : &quot;0@es_supported_clients&quot; , ) ) ) ) ] Now the :link field contains the reference to the original event and the :event contains the full data for the original event. What happens if you try to resolve links for an EventStoreDB stream which is not a projected stream? iex&gt; import Spear.Records.Streams iex&gt; Spear . stream! ( conn , &quot;es_supported_clients&quot; , chunk_size : 1 , resolve_links? : true , raw? : true ) |&gt; Enum . take ( 1 ) [ read_resp ( content : { :event , read_resp_read_event ( event : read_resp_read_event_recorded_event ( data : &quot;{ \\&quot; languages \\&quot; :[ \\&quot; typescript \\&quot; , \\&quot; javascript \\&quot; ], \\&quot; runtime \\&quot; : \\&quot; NodeJS \\&quot; }&quot; , ) , link : :undefined ) ) ) ] Nothing! The events from non-projected streams are unaffected by link resolution choice. Hence the :resolve_links? option is consistently defaulted to true .","ref":"link_resolution.html","title":"Link Resolution","type":"extras"},{"doc":"EventStoreDB has a few options for security which are now all enabled by default in EventStoreDB 20+: connections over TLS (SSL/HTTPS) username+password basic-auth credentials access control lists (ACLs) on streams or globally to an EventStoreDB By default in EventStoreDB 20+, these are all enabled. The EventStoreDB may be run with the --insecure command line flag to disable all of them together.","ref":"security.html","title":"Security","type":"extras"},{"doc":"The EventStore documentation now includes a helpful configuration wizard which will help set up custom or cloud installations of EventStoreDB with the proper networking, config, clustering, and certificates. For any production use-case, see the EventStore documentation. The repository for Spear includes a certs/ directory with some generated certificates. Note that the private keys are included in the repository, so the certificates in that directory are not suitable for any real-world case . Please only use them on a local machine not connected to the internet. Assuming that you're running a Linux machine with the eventstore-oss package installed, we can install the certificates in this repository like so. Note that these commands will probably need to be run through sudo . $ cd /path/to/spear $ mkdir -p /etc/eventstore/certs $ cp -r ./certs/ca /etc/eventstore/certs/ $ cp ./certs/node1/* /etc/eventstore/certs $ cp ./certs/eventstore.conf /etc/eventstore/ $ chown -R eventstore /etc/eventstore/ $ chgrp -R eventstore /etc/eventstore/ $ systemctl restart eventstore Now the EventStoreDB should be set up to force TLS connections. You may need to edit the existing service description to remove the --insecure flag if present.","ref":"security.html#setting-up-an-eventstoredb-for-security","title":"Security - Setting up an EventStoreDB for security","type":"extras"},{"doc":"A Spear.Connection takes an :mint_opts option which is passed to Mint.HTTP.connect/4 . We can inform mint of our custom ./certs/ca/ca.crt CA certificate like so: connection_config = [ connection_string : &quot;esdb://localhost:2113?tls=true&quot; , mint_opts : [ transport_opts : [ cacertfile : Path . join ( [ __DIR__ | ~w(certs ca ca.crt) ] ) ] ] ] # as a supervisor spec: { Spear.Connection , connection_config } # or as a direct call of start_link iex&gt; { :ok , conn } = Spear.Connection . start_link ( connection_config ) Note that this same configuration works with a Spear.Client with this configuration in application-config ( config/*.exs ). If you're following along with the guide and have set up an EventStoreDB with the certificates from the certs/ directory in the spear repository, you should now be able to spawn a connection which will force a TLS connection.","ref":"security.html#using-custom-tls-certificates-with-spear","title":"Security - Using custom TLS certificates with Spear","type":"extras"},{"doc":"Certificates signed by a public certificate authority (CA) such as the Domain Validation (DV) certificates produced by the wonderful Letsencrypt project should work out-of-the-box if the castore dependency is included in your project. # mix.exs .. def deps do [ { :spear , &quot;~&gt; 0.1&quot; } , { :castore , &quot;&gt;= 0.0.0&quot; } ] end .. With castore , you should not need to pass any transport_opts to Mint. connection_config = [ connection_string : &quot;esdb://localhost:2113?tls=true&quot; ] Event Store Cloud uses certificates signed by a public CA, so connections to Managed EventStoreDBs (MESDBs) work out-of-the-box with castore .","ref":"security.html#using-tls-certificates-signed-by-a-public-ca","title":"Security - Using TLS certificates signed by a public CA","type":"extras"},{"doc":"Now that TLS is enabled, we can safely pass basic-auth credentials over the network. Spear.Connection accepts credentials through the connection string or via the :username and :password options. connection_config = [ connection_string : &quot;esdb://admin:changeit@localhost:2113?tls=true&quot; , mint_opts : [ transport_opts : [ cacertfile : Path . join ( [ __DIR__ | ~w(certs ca ca.crt) ] ) ] ] ] Credentials can also be passed on a per-request basis for all core Spear functions (except Spear.ping/2 ; pings do not require/allow authentication as they are not actual requests). All core functions allow a :credentials option two-tuple of {username, password} which override the connection-level credentials if provided. E.g. reading a stream as a user named &quot;Aladdin&quot; (assuming such a user exists): # say we use `connection_config` from above: the connection has credentials # of {&quot;admin&quot;, &quot;changeit&quot;} iex&gt; { :ok , conn } = Spear.Connection . start_link ( connection_config ) # the :credentials option overrides the connection-level credentials iex&gt; Spear . stream! ( conn , &quot;my_stream&quot; , credentials : { &quot;Aladdin&quot; , &quot;open sesame&quot; } ) |&gt; Enum . take ( 1 ) [ % Spear.Event { } ]","ref":"security.html#credentials","title":"Security - Credentials","type":"extras"},{"doc":"Now that we know how to operate the client as a user, how does EventStoreDB use credentials to allow or deny access to resources? EventStoreDB uses access control lists (ACLs) to allow or deny access to various operations per user or group. ACLs (like virtually everything in EventStoreDB) are just events in a stream. A simple ACL event body might look like { &quot;$acl&quot;: { &quot;$w&quot;: &quot;$admins&quot;, &quot;$r&quot;: &quot;$all&quot;, &quot;$d&quot;: &quot;$admins&quot;, &quot;$mw&quot;: &quot;$admins&quot;, &quot;$mr&quot;: &quot;$admins&quot; } } What do each of these mean? value resource $w write events to this stream $r read events from this stream $d delete this stream $mw write metadata associated with this stream $mr read metadata associated with this stream $admins the group of admin users $all all users (including anonymous users) Note that the ACL is controlled by writing stream metadata, so the $mw permission allows a user to change the ACL of a stream. The global ACL The $streams system stream may be used to change the default ACL applied to all streams. By default, the global ACL is { &quot;$userStreamAcl&quot;: { &quot;$r&quot;: &quot;$all&quot;, &quot;$w&quot;: &quot;$all&quot;, &quot;$d&quot;: &quot;$all&quot;, &quot;$mr&quot;: &quot;$all&quot;, &quot;$mw&quot;: &quot;$all&quot; }, &quot;$systemStreamAcl&quot;: { &quot;$r&quot;: &quot;$admins&quot;, &quot;$w&quot;: &quot;$admins&quot;, &quot;$d&quot;: &quot;$admins&quot;, &quot;$mr&quot;: &quot;$admins&quot;, &quot;$mw&quot;: &quot;$admins&quot; } } Where $systemStreamAcl applies to projected and otherwise system-created streams and $userStreamAcl applies to all other (user-created) streams. This default is quite permissive : any user including clients that do not supply any credentials can read and write events to user-streams with the default ACL. The global ACL can be changed by writing an event of type update-default-acl with a content type of application/vnd.eventstore.events+json with the above body to the $streams system stream. Spear provides the Spear.Acl struct and Spear.set_global_acl/4 function to set this without dealing with the nitty-gritty details of the structure of that event. Attempting to access a resource with incorrect or invalid credentials will yield an HTTP 401 error. iex&gt; Spear . set_global_acl ( conn , Spear.Acl . admins_only ( ) , Spear.Acl . admins_only ( ) ) :ok iex&gt; Spear . append ( [ my_event ] , conn , &quot;some_stream&quot; , credentials : { &quot;no one&quot; , &quot;no pass&quot; } ) { :error , % Spear.Grpc.Response { data : &quot;&quot; , message : &quot;Bad HTTP status code: 401, should be 200&quot; , status : :unknown , status_code : 2 } } Attempting to access a resource with no credentials will yield a gRPC error with a status of :permission_denied . Stream-level ACLs EventStoreDB also allows more fine-grained stream-level ACLs to be defined on a per-stream basis. See the Spear.set_stream_metadata/4 function for an example of setting a stream-level ACL.","ref":"security.html#access-control-lists","title":"Security - Access control lists","type":"extras"}]